#-*- coding: windows-1250 -*-

import os

import Tkinter
import Pmw

import sparky
import msfindpeptides
import msfindpeptides_settings
import msduplicated
import mscalib
import msfit
import msfilter
import mssputil
import mstkutil

# -----------------------------------------------------------------------------
#
class find_dialog(mstkutil.Dialog):

	#wywalic parametry view_fits i view_log
	#
	def __init__(self,session,parent_dialog=None,peak=None,view_fits=False,view_log=False):

		self.session=session
		self.parent_dialog=parent_dialog
		self.peak=peak
#		self.entries=[]
		self.spectrum=None
		
		mstkutil.Dialog.__init__(self,session.tk,'MS find peptides')

		Pmw.initialise(session.tk)
		balloon=Pmw.Balloon(self.top,initwait=1500)

		#---------------------------------------------------------------------
		#
		tab_panel=Pmw.NoteBook(self.top,borderwidth=1)
		tab_panel.pack(fill='both',expand=1,padx=1,pady=3)

		#---------------------------------------------------------------------
		#
		tab=tab_panel.add(' Search ')

		#
		f=Pmw.Group(tab,tag_text='Spectrum:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)

		m=mssputil.spectrum_menu(session,f.interior(),'')
		m.frame.pack(side='top',anchor='w',fill='x',padx=2,pady=2)
		m.add_callback(self.select_spectrum)
		self.spectrum_menu=m

		f.interior().columnconfigure(0, weight=1)

		#
		f=Pmw.Group(tab,tag_text='Search settings:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)

		cb=mstkutil.checkbutton(f.interior(),'Search only not present peptides',0)
		cb.button.grid(row=0,column=0,columnspan=2,sticky='w',pady=1)
		self.not_present_only_check=cb
		self.not_present_only_check.add_callback(self.not_present_only_cb)
		
		cb=mstkutil.checkbutton(f.interior(),'Perform spectrum calibration',0)
		cb.button.grid(row=1,column=0,columnspan=2,sticky='w',pady=1)
		self.do_calibration_check=cb
		self.do_calibration_check.add_callback(self.do_calibration_cb)

		cb=mstkutil.checkbutton(f.interior(),'Estimate sprectrum precision',0)
		cb.button.grid(row=2,column=0,columnspan=2,sticky='w',pady=1)
		self.do_estimation_check=cb
		self.do_estimation_check.add_callback(self.do_estimation_cb)

		l=Tkinter.Label(f.interior(),text='m/z SD multiplier: ')
		l.grid(row=3,column=0,sticky='w',padx=20,pady=2)
		
		e=mstkutil.num_entry_field(f.interior(),mstkutil.ENTRY_FP,'',0,20,'',12)
		e.frame.grid(row=3,column=1,sticky='e',padx=3,pady=2)
#		balloon.bind(e.entry,u'Zakres tolerancji m/z chromatogramu\ndla pojedynczego piku.')
		self.entries.append(e)
		self.mz_m_edit=e

		l=Tkinter.Label(f.interior(),text='RT SD multiplier: ')
		l.grid(row=4,column=0,sticky='w',padx=20,pady=2)

		e=mstkutil.num_entry_field(f.interior(),mstkutil.ENTRY_FP,'',0,20,'',12)
		e.frame.grid(row=4,column=1,sticky='e',padx=3,pady=2)
#		balloon.bind(e.entry,u'Zakres tolerancji m/z chromatogramu\ndla pojedynczego piku.')
		self.entries.append(e)
		self.rt_m_edit=e

		cb=mstkutil.checkbutton(f.interior(),'Perform two-step search',0)
		cb.button.grid(row=5,column=0,columnspan=2,sticky='w',pady=1)
		self.do_second_pass_check=cb

	
		f.interior().columnconfigure(0, weight=1)
		f.interior().columnconfigure(1, weight=1)
		
		#
		f=Pmw.Group(tab,tag_text='Current calibration:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)
		
		cb=mstkutil.checkbutton(f.interior(),'Use spectrum m/z calibration',0)
		cb.button.grid(row=0,column=0,sticky='w',padx=2,pady=2)
		self.spectrum_mz_correction_check=cb

		cb=mstkutil.checkbutton(f.interior(),'Use spectrum RT calibration',0)
		cb.button.grid(row=1,column=0,sticky='w',padx=2,pady=2)
		self.spectrum_rt_correction_check=cb

#		cb=mstkutil.checkbutton(f.interior(),'Use spectrum RP calibration',0)
#		cb.button.grid(row=2,column=0,sticky='w',padx=2,pady=2)
#		self.spectrum_rp_correction_check=cb

		f.interior().columnconfigure(0, weight=1)
		
		#
		f=Pmw.Group(tab,tag_text='Postprocessing:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)
		
		cb=mstkutil.checkbutton(f.interior(),'Remove duplicated by:',0)
		cb.button.grid(row=0,column=0,columnspan=2,sticky='w',pady=1)
		self.remove_duplicated_check=cb
		self.remove_duplicated_check.add_callback(self.remove_duplicated_cb)
		
		m=mstkutil.option_menu(f.interior(),'',msduplicated.METHOD_STR)
		m.frame.grid(row=0,column=1,columnspan=2,sticky='e',pady=2,padx=2)
		#balloon.bind(m.menubutton,u'Rodzaj filtru wygadzajcego chromatogram.')
		self.remove_duplicated_menu=m
		
		f.interior().columnconfigure(0, weight=1)
		f.interior().columnconfigure(1, weight=1)
		
		#---------------------------------------------------------------------
		#
		tab=tab_panel.add(' Chromatogram ')

		#
		f=Pmw.Group(tab,tag_text='Chromatogram:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)

		l=Tkinter.Label(f.interior(),text='Number of peaks:')
		l.grid(row=0,column=0,sticky='w',padx=2,pady=2)

		e=mstkutil.num_entry_field(f.interior(),mstkutil.ENTRY_INT,'',0,10,'',12)
		e.frame.grid(row=0,column=1,columnspan=2,sticky='e',padx=2,pady=2)
		balloon.bind(e.entry,u'Liczba pikow uwzgldnianych podczas wyznaczania chromatogramu\n(0 oznacza wszystkie piki obwiedni teoretycznej).')
		self.entries.append(e)
		self.peaks_count_edit=e
		
		l=Tkinter.Label(f.interior(),text='m/z range [ppm]: ')
		l.grid(row=1,column=0,sticky='w',padx=2,pady=2)

		ff=Tkinter.Frame(f.interior())
		ff.grid(row=1,column=1,columnspan=2,sticky='e')
		e=mstkutil.num_entry_field(ff,mstkutil.ENTRY_FP,'',1,1000,'',5)
		e.frame.grid(row=1,column=1,sticky='e',padx=2,pady=2)
		balloon.bind(e.entry,u'Zakres tolerancji m/z chromatogramu\ndla pojedynczego piku.')
		self.entries.append(e)
		self.mz_range_edit1=e

		e=mstkutil.num_entry_field(ff,mstkutil.ENTRY_FP,'',1,1000,'',5)
		e.frame.grid(row=1,column=2,sticky='e',padx=3,pady=2)
		balloon.bind(e.entry,u'Zakres tolerancji m/z chromatogramu\ndla pojedynczego piku.')
		self.entries.append(e)
		self.mz_range_edit2=e

		l=Tkinter.Label(f.interior(),text='Intensity threshold: ')
		l.grid(row=2,column=0,sticky='w',padx=2,pady=2)

		e=mstkutil.num_entry_field(f.interior(),mstkutil.ENTRY_FP,'',1,10000000,'',12)
		e.frame.grid(row=2,column=1,columnspan=2,sticky='e',padx=2,pady=2)
		balloon.bind(e.entry,u'Minimalna warto widma uwzgldniana podczas\nwyznaczania chromatogramu.')
		self.entries.append(e)
		self.threshold_edit=e

		cb=mstkutil.checkbutton(f.interior(),'Require local max. in m/z range',0)
		cb.button.grid(row=3,columnspan=2,sticky='w',padx=2,pady=2)
		balloon.bind(cb.button,u'Zerowanie wartoci chromatogramu gdy w zakresie tolerancji m/z\nnie wystpuje maksimum lokalne widma.')
		self.entries.append(e)
		self.require_max_check=cb

		f.interior().columnconfigure(0, weight=1)
		f.interior().columnconfigure(1, weight=1)
		f.interior().columnconfigure(2, weight=1)

		#
		f=Pmw.Group(tab,tag_text='Filtering:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)

		l=Tkinter.Label(f.interior(),text='Filter type: ')
		l.grid(row=0,column=0,sticky='w',padx=2,pady=2)

		m=mstkutil.option_menu(f.interior(),'',msfilter.FILTER_STR,msfilter.FILTER_STR[msfilter.FILTER_GAUSS])
		m.frame.grid(row=0,column=1,columnspan=2,sticky='e',pady=2,padx=2)
		balloon.bind(m.menubutton,u'Rodzaj filtru wygadzajcego chromatogram.')
		self.filter_type_menu=m
		self.filter_type_menu.add_callback(self.filter_type_cb)

		l=Tkinter.Label(f.interior(),text='Filter span: ')
		l.grid(row=1,column=0,sticky='w',padx=2,pady=2)

		e=mstkutil.num_entry_field(f.interior(),1,'',3,1000000,'',12,cb=self.filter_params_cb)
		balloon.bind(e.entry,u'Szeroko filtru wygadzajcego chromatogram.')
		e.frame.grid(row=1,column=1,sticky='e',padx=2,pady=1)
		self.entries.append(e)
		self.filter_span_edit=e

		l=Tkinter.Label(f.interior(),text='Filter order: ')
		l.grid(row=2,column=0,sticky='w',padx=2,pady=2)

		e=mstkutil.num_entry_field(f.interior(),1,'',0,1000000,'',12,cb=self.filter_params_cb)
		e.frame.grid(row=2,column=1,sticky='e',padx=2,pady=2)
		balloon.bind(e.entry,u'Rzd filtru wygadzajcego chromatogram.')
		self.entries.append(e)
		self.filter_order_edit=e

		f.interior().columnconfigure(0, weight=1)
		f.interior().columnconfigure(1, weight=1)


		#
		f=Pmw.Group(tab,tag_text='Postprocessing:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)

		cb=mstkutil.checkbutton(f.interior(),'Use RT penality function',0)
		balloon.bind(cb.button,u'Funkcja kary za odstpstwo od przewidywanego\nczasu retencji.')
		cb.button.grid(row=0,column=0,columnspan=2,sticky='w',pady=2)
		self.rt_penality_check=cb
		self.rt_penality_check.add_callback(self.rt_penality_cb)

		l=Tkinter.Label(f.interior(),text='Penality function width [min]: ')
		l.grid(row=1,column=0,sticky='w',padx=2,pady=2)

		e=mstkutil.num_entry_field(f.interior(),mstkutil.ENTRY_FP,'',0.01,1000000,'',12)
		balloon.bind(e.entry,u'Seroko funkcji kary za odstpstwo od przewidywanego\nczasu retencji.')
		e.frame.grid(row=1,column=1,sticky='e',padx=2,pady=2)
		self.entries.append(e)
		self.rt_penality_edit=e

		cb=mstkutil.checkbutton(f.interior(),'Eliminate insignificant peaks',0)
		balloon.bind(cb.button,u'Pomijanie mao znaczcych pikw chromatogramu.')
		cb.button.grid(row=2,column=0,columnspan=2,sticky='w',pady=2)
		self.max_elimination_check=cb
		self.max_elimination_check.add_callback(self.max_elimination_cb)

		l=Tkinter.Label(f.interior(),text='Peak elimination threshold: ')
		l.grid(row=3,column=0,sticky='w',padx=2,pady=2)

		e=mstkutil.num_entry_field(f.interior(),mstkutil.ENTRY_FP,'',0,1000000,'',12)
		balloon.bind(e.entry,u'Wspczynnik okrelajcy wymagan stromo zbocza narastajcego piku.')
		e.frame.grid(row=3,column=1,sticky='e',padx=2,pady=2)
		self.entries.append(e)
		self.max_threshold_edit=e

		f.interior().columnconfigure(0, weight=1)
		f.interior().columnconfigure(1, weight=1)

		#---------------------------------------------------------------------
		#
		tab=tab_panel.add(' Fitting ')

		#
		f=Pmw.Group(tab,tag_text='Fit settings:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)

		l=Tkinter.Label(f.interior(),text='Fitted peaks number:')
		l.grid(row=0,column=0,sticky='w',padx=2,pady=2)

		e=mstkutil.num_entry_field(f.interior(),mstkutil.ENTRY_INT,'',1,10,'',12)
		e.frame.grid(row=0,column=1,sticky='e',padx=2,pady=2)
		balloon.bind(e.entry,'Maksymalna liczba pikow uwzgl?dnianych podczas\nwyznaczania dopasowania do obwiedni izotopowej.')
		self.entries.append(e)
		self.fit_peaks_count_edit=e

		l=Tkinter.Label(f.interior(),text='Fit RT for peak: ')
		l.grid(row=1,column=0,sticky='w',padx=2,pady=2)

		m=mstkutil.option_menu(f.interior(),'',('Monoisotopic','Highest'),'Highest')
		m.frame.grid(row=1,column=1,columnspan=2,sticky='e',pady=2)
		self.fit_rt_monoisotopic_menu=m

		f.interior().columnconfigure(0, weight=1)
		f.interior().columnconfigure(1, weight=1)


		#
		f=Pmw.Group(tab,tag_text='Fit acceptance criteria:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)

		cb=mstkutil.checkbutton(f.interior(),u'Min. m/z envelope R\u00B2:',0)
		cb.button.grid(row=0,column=0,sticky='w',padx=2,pady=2)
		self.fit_min_env_rsquare_check=cb
		self.fit_min_env_rsquare_check.add_callback(self.fit_present_cb)
		
		e=mstkutil.num_entry_field(f.interior(),mstkutil.ENTRY_FP,'',0,1,'',12)
		e.frame.grid(row=0,column=1,sticky='e',padx=2,pady=2)
		balloon.bind(e.entry,'Minimalna warto dopasowania do teoretycznej obwiedni izotopowej.')
		self.entries.append(e)
		self.fit_min_env_rsquare_edit=e

		cb=mstkutil.checkbutton(f.interior(),u'Min. RT R\u00B2:',0)
		cb.button.grid(row=1,column=0,sticky='w',padx=2,pady=2)
		self.fit_min_rt_rsquare_check=cb
		self.fit_min_rt_rsquare_check.add_callback(self.fit_present_cb)
		
		e=mstkutil.num_entry_field(f.interior(),mstkutil.ENTRY_FP,'',0,1,'',12)
		e.frame.grid(row=1,column=1,sticky='e',padx=2,pady=2)
		balloon.bind(e.entry,'Minimalna warto dopasowania profilu elucji.')
		self.entries.append(e)
		self.fit_min_rt_rsquare_edit=e

		cb=mstkutil.checkbutton(f.interior(),u'Min. fitted peaks:',0)
		cb.button.grid(row=2,column=0,sticky='w',padx=2,pady=2)
		self.fit_min_peaks_count_check=cb
		self.fit_min_peaks_count_check.add_callback(self.fit_present_cb)
		
		e=mstkutil.num_entry_field(f.interior(),mstkutil.ENTRY_INT,'',1,10,'',12)
		e.frame.grid(row=2,column=1,sticky='e',padx=2,pady=2)
		balloon.bind(e.entry,'Minimalna liczba dopasowaych pikw.')
		self.entries.append(e)
		self.fit_min_peaks_count_edit=e
		
		f.interior().columnconfigure(0, weight=1)
		f.interior().columnconfigure(1, weight=1)
		
		#---------------------------------------------------------------------
		#
		tab=tab_panel.add(' Logs & plots ')

		#
		f=Pmw.Group(tab,tag_text='Lists:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)
		
		cb=mstkutil.checkbutton(f.interior(),'Save peptide list',0)
		cb.button.grid(row=0,columnspan=2,sticky='w',pady=1)
		self.list_save_check=cb
		self.list_save_check.add_callback(self.list_save_cb)

		cb=mstkutil.checkbutton(f.interior(),'Value only for the monoisotopic peak',0)
		cb.button.grid(row=1,columnspan=2,sticky='w',pady=1)
		self.list_only_monoisotopic_check=cb

		cb=mstkutil.checkbutton(f.interior(),'Logarithmic scale',0)
		cb.button.grid(row=2,columnspan=2,sticky='w',pady=1)
		self.list_log_scale_check=cb

		l=Tkinter.Label(f.interior(),text='Value: ')
		l.grid(row=3,column=0,sticky='w')

		m=msfit.value_menu(f.interior(),'')
		m.frame.grid(row=3,column=1,sticky='e',pady=2,padx=2)
		self.list_value_menu=m

		f.interior().columnconfigure(0, weight=1)		
		f.interior().columnconfigure(1, weight=1)		

		#
		f=Pmw.Group(tab,tag_text='Plots:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)

		cb=mstkutil.checkbutton(f.interior(),'Show calibration plots',0)
		cb.button.grid(row=0,column=0,sticky='w',pady=1)
		self.view_second_pass_params_check=cb

		cb=mstkutil.checkbutton(f.interior(),'Save calibration plots',0)
		cb.button.grid(row=1,column=0,sticky='w',pady=1)
		self.save_second_pass_params_check=cb

		cb=mstkutil.checkbutton(f.interior(),'Show fit plots',0)
		cb.button.grid(row=2,column=0,sticky='w',pady=1)
		self.view_fits_check=cb

		f.interior().columnconfigure(0, weight=1)
		
		#
		f=Pmw.Group(tab,tag_text='Logs:')
		f.pack(side='top',anchor='nw',fill='x',padx=0,pady=0)

		cb=mstkutil.checkbutton(f.interior(),'Show search log',0)
		cb.button.grid(row=0,column=0,sticky='w',pady=1)
		self.view_log_check=cb
		
		cb=mstkutil.checkbutton(f.interior(),'Save search log',0)
		cb.button.grid(row=1,column=0,sticky='w',pady=1)
		self.save_log_check=cb

		f.interior().columnconfigure(0, weight=1)

		#
		#
		#
		#
		tab_panel.selectpage(' Search ')
		tab_panel.setnaturalsize()

		#---------------------------------------------------------------------
		#
		br=mstkutil.button_row(self.top,
				('Find', self.find_cb),
				('Close', self.close_cb),
				)
		if self.parent_dialog!=None:
			br.buttons[0]['text']='Apply'

		br.frame.pack(side='top',anchor='e',pady=2)
		self.buttons_row=br

		self.removed_notice=session.notify_me('removed spectrum from project',self.update_spectrum_menu)
		self.added_notice=session.notify_me('added spectrum to project',self.update_spectrum_menu)
		self.top.bind('<Destroy>',self.remove_callbacks,1)

		self.top.geometry("+0+0")
		#self.top.geometry(('%dx%d+%d+%d') % (320,390,0,0))
		self.top.resizable(0,0)


		if self.parent_dialog==None:
			self.settings=msfindpeptides_settings.findpeptides_settings(self.session,os.path.join(os.environ.get('SPARKY_INSTALL'),os.path.join('config','findpeptides.cfg')),view_fits,view_log)
		else:
			self.settings=self.parent_dialog.settings
		self.show_settings(self.settings)

	# ---------------------------------------------------------------------------
	#
	def remove_callbacks(self,event):
		if str(self.top)==str(event.widget):
			if sparky.object_exists(self.session):
				if self.removed_notice!=None:
					self.session.dont_notify_me(self.removed_notice)
				if self.added_notice!=None:
					self.session.dont_notify_me(self.added_notice)

			self.removed_notice=None
			self.added_notice=None

 	# ---------------------------------------------------------------------------
	#
	def close_cb(self):
		if self.parent_dialog!=None:
			self.parent_dialog.settings_dialog=None
		self.top.destroy()
		
	# ---------------------------------------------------------------------------
	#
	def rt_penality_cb(self,event):

		if self.rt_penality_check.variable.get()==1:
			self.rt_penality_edit.entry.configure(state='normal')
		else:
			self.rt_penality_edit.entry.configure(state='disabled')

	# ---------------------------------------------------------------------------
	#
	def max_elimination_cb(self,event):

		if self.max_elimination_check.variable.get()==1:
			self.max_threshold_edit.entry.configure(state='normal')
		else:
			self.max_threshold_edit.entry.configure(state='disabled')

	# ---------------------------------------------------------------------------
	#
	def filter_type_cb(self,event=None):
	
		filter_type=self.filter_type_menu.variable.get()

		if filter_type==msfilter.FILTER_STR[msfilter.FILTER_NONE]:
			self.filter_span_edit.entry.configure(state='disabled')
			self.filter_order_edit.entry.configure(state='disabled')
		else:
			self.filter_span_edit.entry.configure(state='normal')
			if filter_type==msfilter.FILTER_STR[msfilter.FILTER_GAUSS]:
				self.filter_span_edit.entry_type=mstkutil.ENTRY_FP
				self.filter_span_edit.min_value=0
				#uzaleznic filter span od zakresu RT
				self.filter_span_edit.variable.set(1.5)
				self.filter_order_edit.min_value=0
				self.filter_order_edit.max_value=2
				self.filter_order_edit.variable.set(0)
				state='normal'
			else:
				self.filter_span_edit.entry_type=mstkutil.ENTRY_INT
				if filter_type==msfilter.FILTER_STR[msfilter.FILTER_SG]:
					self.filter_span_edit.min_value=5
					self.filter_span_edit.variable.set(5)
					self.filter_order_edit.min_value=2
					self.filter_order_edit.max_value=100
					self.filter_order_edit.variable.set(2)
					state='normal'
				else:
					self.filter_span_edit.min_value=3
					self.filter_span_edit.variable.set(3)
					self.filter_order_edit.min_value=0
					self.filter_order_edit.variable.set(0)
					state='disabled'
			self.filter_order_edit.entry.configure(state=state)

	# ---------------------------------------------------------------------------
	#
	def fit_present_cb(self,event):

		if self.fit_min_env_rsquare_check.variable.get()==1:
			self.fit_min_env_rsquare_edit.entry.configure(state='normal')
		else:
			self.fit_min_env_rsquare_edit.entry.configure(state='disabled')

		if self.fit_min_rt_rsquare_check.variable.get()==1:
			self.fit_min_rt_rsquare_edit.entry.configure(state='normal')
		else:
			self.fit_min_rt_rsquare_edit.entry.configure(state='disabled')

		if self.fit_min_peaks_count_check.variable.get()==1:
			self.fit_min_peaks_count_edit.entry.configure(state='normal')
		else:
			self.fit_min_peaks_count_edit.entry.configure(state='disabled')
			
	# ---------------------------------------------------------------------------
	#
	def filter_params_cb(self,event=None):
		result=True
		span_error=False
		order_error=False

		if self.filter_span_edit.validate()==None:
			span_error=True
		if self.filter_order_edit.validate()==None:
			order_error=True
		
		if span_error==False and order_error==False:
			filter_type=self.filter_type_menu.variable.get()
			if filter_type!=msfilter.FILTER_STR[msfilter.FILTER_GAUSS]:
				span=int(self.filter_span_edit.variable.get())
				order=int(self.filter_order_edit.variable.get())

				if span%2!=1:
					span_error=True
				if filter_type==msfilter.FILTER_STR[msfilter.FILTER_SG] and span <= order+2:
					order_error=True

		if span_error==True:
			self.filter_span_edit.entry.configure(background='pink')
		else:
			self.filter_span_edit.entry.configure(background='white')

		if order_error==True:
			self.filter_order_edit.entry.configure(background='pink')
		else:
			self.filter_order_edit.entry.configure(background='white')

		result=(not span_error and not order_error)

		return result

	# ---------------------------------------------------------------------------
	#
	def not_present_only_cb(self,event=None):
		if self.not_present_only_check.variable.get()==1:
			self.do_calibration_check.variable.set(0)
			self.do_calibration_check.button.configure(state='disabled')
		else:
			self.do_calibration_check.variable.set(self.settings.calibration)
			self.do_calibration_check.button.configure(state='normal')
		self.do_calibration_cb()
		
	# ---------------------------------------------------------------------------
	#
	def do_calibration_cb(self,event=None):
		if self.do_calibration_check.variable.get()==1:
			self.do_second_pass_check.variable.set(self.settings.second_pass)
			self.do_second_pass_check.button.configure(state='normal')
			self.do_estimation_check.variable.set(self.settings.estimation)
			self.do_estimation_check.button.configure(state='normal')
			self.view_second_pass_params_check.variable.set(self.settings.view_second_pass_params)
			self.view_second_pass_params_check.button.configure(state='normal')
		else:
			self.do_second_pass_check.variable.set(0)
			self.do_second_pass_check.button.configure(state='disabled')
			self.do_estimation_check.variable.set(0)
			self.do_estimation_check.button.configure(state='disabled')
			self.view_second_pass_params_check.variable.set(0)
			self.view_second_pass_params_check.button.configure(state='disabled')
		self.do_estimation_cb()

	# ---------------------------------------------------------------------------
	#
	def do_estimation_cb(self,event=None):
		if self.do_estimation_check.variable.get()==1:
			self.mz_m_edit.entry.configure(state='normal')
			self.rt_m_edit.entry.configure(state='normal')
		else:
			self.mz_m_edit.entry.configure(state='disabled')
			self.rt_m_edit.entry.configure(state='disabled')
	
	# ---------------------------------------------------------------------------
	#
	def remove_duplicated_cb(self,event=None):
		if self.remove_duplicated_check.variable.get()==1:
			self.remove_duplicated_menu.menubutton.configure(state='normal')
			self.remove_duplicated_menu.menubutton.configure(state='normal')
		else:
			self.remove_duplicated_menu.menubutton.configure(state='disabled')
			self.remove_duplicated_menu.menubutton.configure(state='disabled')
	
	# ---------------------------------------------------------------------------
	#
	def list_save_cb(self,event):

		self.list_value_menu.set_value(self.settings.list_data_height)
		self.list_log_scale_check.variable.set(self.settings.list_log_scale)
		self.list_only_monoisotopic_check.variable.set(self.settings.list_only_monoisotopic)	
		if self.list_save_check.variable.get()==1:
			self.list_value_menu.menubutton.configure(state='normal')
			self.list_log_scale_check.button.configure(state='normal')
			self.list_only_monoisotopic_check.button.configure(state='normal')
		else:
			self.list_value_menu.menubutton.configure(state='disabled')
			self.list_log_scale_check.button.configure(state='disabled')
			self.list_only_monoisotopic_check.button.configure(state='disabled')
			
	# ---------------------------------------------------------------------------
	#
	def select_spectrum(self,event):
		self.show_spectrum_info(self.spectrum_menu.spectrum())

	# ---------------------------------------------------------------------------
	#
	def update_spectrum_menu(self,removed_spectrum):
		if self.parent_dialog==None:
			spectra=self.session.project.spectrum_list()
			if spectra==None or len(spectra)==0:
				self.top.destroy()
			else:
				if self.spectrum!=removed_spectrum:
					spectrum=self.spectrum
				else:
					spectrum=spectra[0]

				self.spectrum_menu.update_menu_cb()
				self.show_spectrum_info(spectrum)

	# ---------------------------------------------------------------------------
	#
	def find_cb(self):
		if self.get_settings()==False:
			return

		if self.parent_dialog!=None:
			self.show_window(0)
			self.parent_dialog.apply_cb(self.settings)
			self.close_cb()
		else:
			self.close_cb()
			d=msfindpeptides.show_autofind_peptides_dialog(self.session,self.spectrum,self.settings,peak=self.peak)
			d.top.destroy()

	# ---------------------------------------------------------------------------
	#
	def show_spectrum_info(self,spectrum):

		if spectrum!=None:
			self.spectrum=spectrum
			self.spectrum_menu.set(spectrum.name)

			spectrum_settings=msfindpeptides_settings.get_search_settings(self.spectrum)
			self.show_settings(spectrum_settings)
	
	# ---------------------------------------------------------------------------
	#
	def show_settings(self,settings):

		if self.parent_dialog!=None:
			self.spectrum_menu.add_entry('All spectra')
			self.spectrum_menu.variable.set('All spectra')
			self.spectrum_menu.menubutton.configure(state='disabled')

		self.not_present_only_check.variable.set(settings.not_present_only)
		if self.peak!=None:
			self.not_present_only_check.variable.set(0)
			self.not_present_only_check.button.configure(state='disabled')

		self.do_calibration_check.variable.set(settings.calibration)
		if self.peak!=None:
			self.do_calibration_check.variable.set(0)
			self.do_calibration_check.button.configure(state='disabled')

		self.do_estimation_check.variable.set(settings.estimation)
		if self.peak!=None:
			self.do_estimation_check.variable.set(0)
			self.do_estimation_check.button.configure(state='disabled')

		self.mz_m_edit.variable.set(settings.mz_estimation_m)
		if self.peak!=None:
			self.mz_m_edit.entry.configure(state='disabled')
			
		self.rt_m_edit.variable.set(settings.rt_estimation_m)
		if self.peak!=None:
			self.rt_m_edit.entry.configure(state='disabled')
			
		self.do_second_pass_check.variable.set(settings.second_pass)
		if self.peak!=None:
			self.do_second_pass_check.variable.set(0)
			self.do_second_pass_check.button.configure(state='disabled')
			
		if self.spectrum==None or self.spectrum.calibrated==0:
			self.spectrum_mz_correction_check.variable.set(0)
			self.spectrum_mz_correction_check.button.configure(state='disabled')
			#self.spectrum_rp_correction_check.variable.set(0)
			#self.spectrum_rp_correction_check.button.configure(state='disabled')
			self.spectrum_rt_correction_check.variable.set(0)
			self.spectrum_rt_correction_check.button.configure(state='disabled')
		else:
			self.spectrum_mz_correction_check.button.configure(state='normal')
			#self.spectrum_rp_correction_check.button.configure(state='normal')
			self.spectrum_rt_correction_check.button.configure(state='normal')
			if self.peak!=None or settings.not_present_only==1:
				self.spectrum_mz_correction_check.variable.set(1)
				#self.spectrum_rp_correction_check.variable.set(1)
				self.spectrum_rt_correction_check.variable.set(1)
			else:
				self.spectrum_mz_correction_check.variable.set(settings.spectrum_mz_correction)
				#self.spectrum_rp_correction_check.variable.set(settings.spectrum_rp_correction)
				self.spectrum_rt_correction_check.variable.set(settings.spectrum_rt_correction)

		self.remove_duplicated_check.variable.set(settings.remove_duplicated)
		if self.peak!=None:
			self.remove_duplicated_check.variable.set(0)
			self.remove_duplicated_check.button.configure(state='disabled')
		self.remove_duplicated_menu.variable.set(msduplicated.METHOD_STR[settings.remove_duplicated_method])
		
		#Chromatogram
		self.peaks_count_edit.variable.set(settings.ch_peaks_count)
		self.mz_range_edit1.variable.set(settings.ch_mz_margin[0])
		self.mz_range_edit2.variable.set(settings.ch_mz_margin[1])
		self.threshold_edit.variable.set(settings.ch_threshold)
		self.require_max_check.variable.set(settings.ch_require_max)

		self.filter_type_menu.variable.set(msfilter.FILTER_STR[settings.ch_filter_type])
		self.filter_span_edit.variable.set(settings.ch_filter_span)
		self.filter_order_edit.variable.set(settings.ch_filter_order)
		self.filter_params_cb(None)

		self.rt_penality_check.variable.set(settings.ch_rt_penality)
		self.rt_penality_edit.variable.set(settings.ch_rt_penality_s)

		self.max_elimination_check.variable.set(settings.ch_max_elimination)
		self.max_threshold_edit.variable.set(settings.ch_max_threshold)

		#Fit
		self.fit_peaks_count_edit.variable.set(settings.fit_peaks_count)
		if self.settings.fit_rt_monoisotopic==True:
			self.fit_rt_monoisotopic_menu.variable.set('Monoisotopic')
		else:
			self.fit_rt_monoisotopic_menu.variable.set('Highest')
		
		self.fit_min_env_rsquare_check.variable.set(settings.fit_present_env_rsquare)
		self.fit_min_env_rsquare_edit.variable.set(settings.fit_present_env_rsquare_th)
		self.fit_min_rt_rsquare_check.variable.set(settings.fit_present_rt_rsquare)		
		self.fit_min_rt_rsquare_edit.variable.set(settings.fit_present_rt_rsquare_th)
		self.fit_min_peaks_count_check.variable.set(settings.fit_present_peaks_count)		
		self.fit_min_peaks_count_edit.variable.set(settings.fit_present_peaks_count_th)

		#Logs & plots
		self.view_log_check.variable.set(settings.view_log)
		if self.peak!=None:
			self.view_log_check.variable.set(1)
		self.save_log_check.variable.set(settings.save_log)
		if self.peak!=None:
			self.save_log_check.variable.set(0)
			self.save_log_check.button.configure(state='disabled')
		self.view_second_pass_params_check.variable.set(settings.view_second_pass_params)
		if self.peak!=None:
			self.view_second_pass_params_check.variable.set(0)
			self.view_second_pass_params_check.button.configure(state='disabled')
		self.save_second_pass_params_check.variable.set(settings.save_second_pass_params)
		if self.peak!=None:
			self.save_second_pass_params_check.variable.set(0)
			self.save_second_pass_params_check.button.configure(state='disabled')
		self.view_fits_check.variable.set(settings.view_fits)
		if self.peak!=None:
			self.view_fits_check.variable.set(1)
		self.list_save_check.variable.set(self.settings.list_save)
		if self.peak!=None:
			self.list_save_check.variable.set(0)
			self.list_save_check.button.configure(state='disabled')

	# ---------------------------------------------------------------------------
	#
	def get_settings(self):
		
		if self.filter_params_cb()==False:
			mstkutil.warning_dialog(self.top,'Incorrect value detected!!!',title='Warning')
			return False

		if not self.check_entries():
			return False

		#Search
		self.settings.not_present_only=self.not_present_only_check.variable.get()
		self.settings.second_pass=self.do_second_pass_check.variable.get()
		
		self.settings.calibration=self.do_calibration_check.variable.get()
		if self.settings.calibration==0:
			self.settings.rp_calibration_method=mscalib.CALIB_NONE
			self.settings.mz_calibration_method=mscalib.CALIB_NONE
			self.settings.rt_calibration_method=mscalib.CALIB_NONE

		self.settings.estimation=self.do_estimation_check.variable.get()
		self.settings.mz_estimation_m=float(self.mz_m_edit.variable.get())
		self.settings.rt_estimation_m=float(self.rt_m_edit.variable.get())
		
		self.settings.spectrum_rt_correction=self.spectrum_rt_correction_check.variable.get()
		#self.settings.spectrum_rp_correction=self.spectrum_rp_correction_check.variable.get()
		self.settings.spectrum_mz_correction=self.spectrum_mz_correction_check.variable.get()

		self.settings.remove_duplicated=self.remove_duplicated_check.variable.get()
		self.settings.remove_duplicated_method=msduplicated.get_remove_method(self.remove_duplicated_menu.variable.get())
		
		#Chromatogram
		self.settings.ch_peaks_count=int(self.peaks_count_edit.variable.get())
		self.settings.ch_mz_margin=(float(self.mz_range_edit1.variable.get()),float(self.mz_range_edit2.variable.get()))
		self.settings.ch_threshold=float(self.threshold_edit.variable.get())
		if self.require_max_check.variable.get()==1:
			self.settings.ch_require_max=True
		else:
			self.settings.ch_require_max=False

		self.settings.ch_filter_type=msfilter.get_filter_type(self.filter_type_menu.variable.get())
		if self.settings.ch_filter_type==msfilter.FILTER_NONE:
			self.settings.ch_filter_span=0
		elif self.settings.ch_filter_type==msfilter.FILTER_GAUSS:
			self.settings.ch_filter_span=float(self.filter_span_edit.variable.get())
		else:
			self.settings.ch_filter_span=int(self.filter_span_edit.variable.get())
		self.settings.ch_filter_order=int(self.filter_order_edit.variable.get())

		self.settings.ch_rt_penality=self.rt_penality_check.variable.get()
		if self.settings.ch_rt_penality==0:
			self.settings.ch_rt_penality_s=0
		else:
			self.settings.ch_rt_penality_s=float(self.rt_penality_edit.variable.get())

		self.settings.ch_max_elimination=self.max_elimination_check.variable.get()
		if self.settings.ch_max_elimination==True:
			self.settings.ch_max_threshold=float(self.max_threshold_edit.variable.get())
		else:
			self.settings.ch_max_threshold=0

		#Fit
		self.settings.fit_peaks_count=int(self.fit_peaks_count_edit.variable.get())
		if self.fit_rt_monoisotopic_menu.variable.get()=='Monoisotopic':
			self.settings.fit_rt_monoisotopic=True
		else:
			self.settings.fit_rt_monoisotopic=False

		self.settings.fit_present_env_rsquare=self.fit_min_env_rsquare_check.variable.get()
		self.settings.fit_present_env_rsquare_th=float(self.fit_min_env_rsquare_edit.variable.get())
				
		self.settings.fit_present_rt_rsquare=self.fit_min_rt_rsquare_check.variable.get()		
		self.settings.fit_present_rt_rsquare_th=float(self.fit_min_rt_rsquare_edit.variable.get())
		
		self.settings.fit_present_peaks_count=self.fit_min_peaks_count_check.variable.get()		
		self.settings.fit_present_peaks_count_th=int(self.fit_min_peaks_count_edit.variable.get())
		self.settings.fit_present_peaks_count_th=min(self.settings.fit_present_peaks_count_th,self.settings.fit_peaks_count)
		
		#Logs & plots
		self.settings.view_fits=self.view_fits_check.variable.get()
		self.settings.view_log=self.view_log_check.variable.get()
		self.settings.save_log=self.save_log_check.variable.get()
		self.settings.view_second_pass_params=self.view_second_pass_params_check.variable.get()
		self.settings.save_second_pass_params=self.save_second_pass_params_check.variable.get()
		self.settings.list_save=self.list_save_check.variable.get()
		
		self.iteration=0
		self.stop=0

		return True

# -----------------------------------------------------------------------------
#
def show_peptides_dialog(session,parent_dialog):

	d=find_dialog(session,parent_dialog)
	d.show_window(1)

	return d

# -----------------------------------------------------------------------------
#
def show_find_peptides_dialog(session):

	spectrum=session.selected_spectrum()
	if spectrum==None:
		return

	d=find_dialog(session)
	d.show_window(1)
	d.show_spectrum_info(spectrum)

# -----------------------------------------------------------------------------
#
def show_find_peptide_dialog(peak):

	spectrum=peak.spectrum

	d=find_dialog(peak.spectrum.session,None,peak,True,True)
	d.show_window(1)
	d.show_spectrum_info(spectrum)

# -----------------------------------------------------------------------------
#
def show_find_selected_peptide_dialog(session):

	spectrum=session.selected_spectrum()
	if spectrum!=None and hasattr(spectrum,'is_ms'):
		peaks=spectrum.selected_peaks()
		if peaks!=None and len(peaks)==1 and peaks[0].note!=None and peaks[0].note!='':
			peak=peaks[0]
			d=find_dialog(peak.spectrum.session,None,peak,True,True)
			d.show_window(1)
			d.show_spectrum_info(spectrum)