import sys
import os
import Tkinter

import msfit
import msfindpeptides_settings
import mstkutil

class peptideslist_settings:

	def __init__(self,session,path=None):

		self.session=session
		self.lock_callbacks=0
		self.loaded=0

		if path!=None:
			self.loaded=self.read_settings(path)

		self.delta_mz_ppm=1


		try:
			num=int(self.session.project.saved_value('PL2_DELTA_MZ_CORRECTION'))
			if num<0 or num>1:
				raise ValueError
			self.delta_mz_correction=num
		except (ValueError,TypeError):
			self.delta_mz_correction=1

		try:
			num=int(self.session.project.saved_value('PL2_DELTA_MZ'))
			if num<0 or num>1:
				raise ValueError
			self.delta_mz_check=num
		except (ValueError,TypeError):
			self.delta_mz_check=0

		try:
			num=float(self.session.project.saved_value('PL2_DELTA_MZ_TH'))
			if num<0:
				raise ValueError
			self.delta_mz_th=num
		except (ValueError,TypeError):
			self.delta_mz_th=20

		try:
			num=int(self.session.project.saved_value('PL2_DELTA_RT_CORRECTION'))
			if num<0 or num>1:
				raise ValueError
			self.delta_mrt_correction=num
		except (ValueError,TypeError):
			self.delta_mrt_correction=1

		try:
			num=int(self.session.project.saved_value('PL2_DELTA_MRT'))
			if num<0 or num>1:
				raise ValueError
			self.delta_mrt_check=num
		except (ValueError,TypeError):
			self.delta_mrt_check=0

		try:
			num=float(self.session.project.saved_value('PL2_DELTA_MRT_TH'))
			if num<0:
				raise ValueError
			self.delta_mrt_th=num
		except (ValueError,TypeError):
			self.delta_mrt_th=3

		try:
			num=int(self.session.project.saved_value('PL2_MZ_RMS'))
			if num<0 or num>1:
				raise ValueError
			self.mz_rms_check=num
		except (ValueError,TypeError):
			self.mz_rms_check=0

		try:
			num=float(self.session.project.saved_value('PL2_MZ_RMS_TH'))
			if num<0:
				raise ValueError
			self.mz_rms_th=num
		except (ValueError,TypeError):
			self.mz_rms_th=100

		try:
			num=int(self.session.project.saved_value('PL2_MZ_RSQUARE'))
			if num<0 or num>1:
				raise ValueError
			self.mz_rsquare_check=num
		except (ValueError,TypeError):
			self.mz_rsquare_check=0

		try:
			num=float(self.session.project.saved_value('PL2_MZ_RSQUARE_TH'))
			if num<0:
				raise ValueError
			self.mz_rsquare_th=num
		except (ValueError,TypeError):
			self.mz_rsquare_th=0.9

		try:
			num=int(self.session.project.saved_value('PL2_MZ_FLAG'))
			if num<0 or num>1:
				raise ValueError
			self.mz_flag_check=num
		except (ValueError,TypeError):
			self.mz_flag_check=0

		try:
			num=int(self.session.project.saved_value('PL2_ENV_RMS'))
			if num<0 or num>1:
				raise ValueError
			self.mz_env_rms_check=num
		except (ValueError,TypeError):
			self.mz_env_rms_check=0

		try:
			num=float(self.session.project.saved_value('PL2_ENV_RMS_TH'))
			if num<0:
				raise ValueError
			self.mz_env_rms_th=num
		except (ValueError,TypeError):
			self.mz_env_rms_th=100

		try:
			num=int(self.session.project.saved_value('PL2_ENV_RSQUARE'))
			if num<0 or num>1:
				raise ValueError
			self.mz_env_rsquare_check=num
		except (ValueError,TypeError):
			self.mz_env_rsquare_check=0

		try:
			num=float(self.session.project.saved_value('PL2_ENV_RSQUARE_TH'))
			if num<0:
				raise ValueError
			self.mz_env_rsquare_th=num
		except (ValueError,TypeError):
			self.mz_env_rsquare_th=0.9

		try:
			num=int(self.session.project.saved_value('PL2_RT_RMS'))
			if num<0 or num>1:
				raise ValueError
			self.rt_rms_check=num
		except (ValueError,TypeError):
			self.rt_rms_check=0

		try:
			num=float(self.session.project.saved_value('PL2_RT_RMS_TH'))
			if num<0:
				raise ValueError
			self.rt_rms_th=num
		except (ValueError,TypeError):
			self.rt_rms_th=100

		try:
			num=int(self.session.project.saved_value('PL2_RT_RSQUARE'))
			if num<0 or num>1:
				raise ValueError
			self.rt_rsquare_check=num
		except (ValueError,TypeError):
			self.rt_rsquare_check=0

		try:
			num=float(self.session.project.saved_value('PL2_RT_RSQUARE_TH'))
			if num<0:
				raise ValueError
			self.rt_rsquare_th=num
		except (ValueError,TypeError):
			self.rt_rsquare_th=0.9

		try:
			num=int(self.session.project.saved_value('PL2_RT_FLAG'))
			if num<0 or num>1:
				raise ValueError
			self.rt_flag_check=num
		except (ValueError,TypeError):
			self.rt_flag_check=0

		try:
			num=int(self.session.project.saved_value('PL2_FIT_RMS'))
			if num<0 or num>1:
				raise ValueError
			self.fit_rms_check=num
		except (ValueError,TypeError):
			self.fit_rms_check=0

		try:
			num=float(self.session.project.saved_value('PL2_FIT_RMS_TH'))
			if num<0:
				raise ValueError
			self.fit_rms_th=num
		except (ValueError,TypeError):
			self.fit_rms_th=1000

		try:
			num=int(self.session.project.saved_value('PL2_PEAKS'))
			if num<0 or num>1:
				raise ValueError
			self.peaks_check=num
		except (ValueError,TypeError):
			self.peaks_check=0

		try:
			num=float(self.session.project.saved_value('PL2_PEAKS_TH'))
			if num<1:
				raise ValueError
			self.peaks_th=num
		except (ValueError,TypeError):
			self.peaks_th=2

		try:
			num=int(self.session.project.saved_value('PL2_NAN_UNCHECKED'))
			if num<0 or num>1:
				raise ValueError
			self.nan_unchecked=num
		except (ValueError,TypeError):
			self.nan_unchecked=1

		try:
			num=int(self.session.project.saved_value('PL2_MARK_UNCHECKED'))
			if num<0 or num>1:
				raise ValueError
			self.flag_unchecked=num
		except (ValueError,TypeError):
			self.flag_unchecked=0

		try:
			num=int(self.session.project.saved_value('PL2_VALUE'))
			if num<msfit.VALUE_DATA_HEIGHT or num>msfit.VALUE_SFIT_VOLUME:
				raise ValueError
			self.data_height=num
		except (ValueError,TypeError):
			self.data_height=msfit.VALUE_DATA_HEIGHT

		self.log_scale=Tkinter.IntVar()
		try:
			num=int(self.session.project.saved_value('PL2_LOG_SCALE'))
			if num<0 or num>1:
				raise ValueError
			self.log_scale.set(num)
		except (ValueError,TypeError):
			self.log_scale.set(0)

		self.only_monoisotopic=Tkinter.IntVar()
		try:
			num=int(self.session.project.saved_value('PL2_ONLY_MONOISOTOPIC'))
			if num<0 or num>1:
				raise ValueError
			self.only_monoisotopic.set(num)
		except (ValueError,TypeError):
			self.only_monoisotopic.set(1)

		self.view_all=Tkinter.StringVar()
		self.view_all.set(self.session.project.saved_value('PL2_VIEW_ALL'))
		if self.view_all.get()!='A' and self.view_all.get()!='M' and self.view_all.get()!='NM' and self.view_all.get()!='P' and self.view_all.get()!='NP':
			self.view_all.set('A')

		self.view_list_only=Tkinter.IntVar()
		self.view_list_only.set(0)
		self.view_list=None

		self.check=-1

	# --------------------------------------------------------------------------
	#
	def read_settings(self,path):
		result=0

		if path!=None:
			try:
				file=open(path,'r')
				lines=file.readlines()

				for i in range(0,len(lines)):
					line=lines[i].strip()
					if len(line)!=0 and line[0]!='#':
						fields=lines[i].split('=')
						if len(fields)==2:
							self.session.project.save_value(fields[0].strip(),fields[1].strip())
				file.close()
				result=1
			except IOError, (errno, strerror):
				print "I/O error(%s): %s" % (errno, strerror)
				result=0

		return result


# --------------------------------------------------------------------------
#
def get_peptideslist_settings(spectrum):

	settings=peptideslist_settings(spectrum.session,os.path.join(os.environ.get('SPARKY_INSTALL'),os.path.join('config','peptideslist2.cfg')))

	if spectrum.processed==1 and spectrum.ms_processing!=None and len(spectrum.ms_processing)>1:
		search_settings=msfindpeptides_settings.get_search_settings(spectrum)

		settings.delta_mz_th=search_settings.ch_mz_margin[0]
		settings.delta_mrt_th=search_settings.ch_rt_penality_s/2

	return settings

# -----------------------------------------------------------------------------
#
class peptideslist_settings_dialog(mstkutil.Settings_Dialog):

	def __init__(self, session):
		self.session=session
		self.loaded=0
		mstkutil.Settings_Dialog.__init__(self,session.tk,'Settings')

		f=Tkinter.Frame(self.top,borderwidth=2,relief='groove')
		f.pack(side='top',anchor='w',pady=2,fill='x',expand=1)

		l=Tkinter.Label(f,text='Value: ')
		l.grid(row=0,column=0,sticky='w')

		m=msfit.value_menu(f,'')
		m.frame.grid(row=0,column=1,sticky='w',pady=2,padx=2)
		self.value_menu=m

		cb=mstkutil.checkbutton(f,'Value only from monoisotopic peak',0)
		cb.button.grid(row=1,columnspan=2,sticky='w',pady=1)
		self.only_monoisotopic_check=cb

		cb=mstkutil.checkbutton(f,'Logarithmic scale',0)
		cb.button.grid(row=2,columnspan=2,sticky='w',pady=1)
		self.log_scale_check=cb

		cb=mstkutil.checkbutton(f,'Set value to NaN for not present',0)
		cb.button.grid(row=3,columnspan=2,sticky='w',pady=1)
		self.nan_unchecked_check=cb

		cb=mstkutil.checkbutton(f,'Mark not present',0)
		cb.button.grid(row=4,columnspan=2,sticky='w',pady=1)
		self.flag_unchecked_check=cb

		cb=mstkutil.checkbutton(f,'Delta m/z [ppm]: ',0)
		cb.button.grid(row=5,column=0,sticky='w')
		self.delta_mz_check=cb

		e=mstkutil.entry_field(f,'','0',7,None,'right')
		e.frame.grid(row=5,column=1,sticky='w',padx=2,pady=1)
		self.delta_mz_edit=e

		cb=mstkutil.checkbutton(f,'Use spectrum m/z correction',0)
		cb.button.grid(row=6,columnspan=2,sticky='w',pady=1)
		self.delta_mz_correction_check=cb

		cb=mstkutil.checkbutton(f,'m/z fit RMS:',0)
		cb.button.grid(row=7,column=0,sticky='w')
		self.mz_rms_check=cb

		e=mstkutil.entry_field(f,'','0',7,None,'right')
		e.frame.grid(row=7,column=1,sticky='w',padx=2,pady=2)
		self.mz_rms_edit=e

		cb=mstkutil.checkbutton(f,'m/z fit R-square:',0)
		cb.button.grid(row=8,column=0,sticky='w')
		self.mz_rsquare_check=cb

		e=mstkutil.entry_field(f,'','0',7,None,'right')
		e.frame.grid(row=8,column=1,sticky='w',padx=2,pady=2)
		self.mz_rsquare_edit=e

		cb=mstkutil.checkbutton(f,'m/z fit flag',0)
		cb.button.grid(row=9,columnspan=2,sticky='w')
		self.mz_flag_check=cb

		cb=mstkutil.checkbutton(f,'Delta RT [min]: ',0)
		cb.button.grid(row=10,column=0,sticky='w')
		self.delta_mrt_check=cb

		e=mstkutil.entry_field(f,'','0',7,None,'right')
		e.frame.grid(row=10,column=1,sticky='w',padx=2,pady=1)
		self.delta_mrt_edit=e

		cb=mstkutil.checkbutton(f,'Use spectrum RT correction',0)
		cb.button.grid(row=11,columnspan=2,sticky='w',pady=1)
		self.delta_mrt_correction_check=cb

		cb=mstkutil.checkbutton(f,'RT fit RMS:',0)
		cb.button.grid(row=12,column=0,sticky='w')
		self.rt_rms_check=cb

		e=mstkutil.entry_field(f,'','0',7,None,'right')
		e.frame.grid(row=12,column=1,sticky='w',padx=2,pady=2)
		self.rt_rms_edit=e

		cb=mstkutil.checkbutton(f,'RT fit R-square:',0)
		cb.button.grid(row=13,column=0,sticky='w')
		self.rt_rsquare_check=cb

		e=mstkutil.entry_field(f,'','0',7,None,'right')
		e.frame.grid(row=13,column=1,sticky='w',padx=2,pady=2)
		self.rt_rsquare_edit=e

		cb=mstkutil.checkbutton(f,'RT fit flag',0)
		cb.button.grid(row=14,columnspan=2,sticky='w')
		self.rt_flag_check=cb

		cb=mstkutil.checkbutton(f,'Envelope RMS:',0)
		cb.button.grid(row=15,column=0,sticky='w')
		self.mz_env_rms_check=cb

		e=mstkutil.entry_field(f,'','0',7,None,'right')
		e.frame.grid(row=15,column=1,sticky='w',padx=2,pady=2)
		self.mz_env_rms_edit=e

		cb=mstkutil.checkbutton(f,'Envelope R-square:',0)
		cb.button.grid(row=16,column=0,sticky='w')
		self.mz_env_rsquare_check=cb

		e=mstkutil.entry_field(f,'','0',7,None,'right')
		e.frame.grid(row=16,column=1,sticky='w',padx=2,pady=2)
		self.mz_env_rsquare_edit=e

		cb=mstkutil.checkbutton(f,'Envelope peaks:',0)
		cb.button.grid(row=17,column=0,sticky='w')
		self.peaks_check=cb

		e=mstkutil.entry_field(f,'','0',7,None,'right')
		e.frame.grid(row=17,column=1,sticky='w',padx=2,pady=2)
		self.peaks_edit=e

		cb=mstkutil.checkbutton(f,'Fit RMS:',0)
		cb.button.grid(row=18,column=0,sticky='w')
		self.fit_rms_check=cb

		e=mstkutil.entry_field(f,'','0',7,None,'right')
		e.frame.grid(row=18,column=1,sticky='w',padx=2,pady=2)
		self.fit_rms_edit=e

		l=Tkinter.Label(f,text='View:')
		l.grid(row=19,column=0,sticky='w',pady=1)

		m=mstkutil.option_menu(f,'',('All','Marked','Not marked','Present','Not present'),'All')
		m.frame.grid(row=19,column=1,sticky='w',pady=2,padx=2)
		self.view_menu=m

		cb=mstkutil.checkbutton(f,'Show only peptides from list',0)
		cb.button.grid(row=20,columnspan=2,sticky='w',pady=1)
		self.view_list_check=cb

		b=Tkinter.Button(f,text='Load list',borderwidth=1,width='12',command=self.load_list_cb)
		b.grid(row=21,column=0,sticky='w',padx=2,pady=2)

		b=Tkinter.Button(f,text='Clear list',borderwidth=1,width='12',command=self.clear_list_cb)
		b.grid(row=21,column=1,sticky='w',padx=2,pady=2)

		cb=mstkutil.checkbutton(f,'Exact charges',0)
		cb.button.grid(row=22,columnspan=2,sticky='w',pady=2)
		self.list_charge_check=cb

		br=mstkutil.button_row(self.top,
				('Apply', self.apply_settings_cb),
				('Load', self.load_cb),
				('Close', self.close_cb),
				)
		br.frame.pack(side='bottom',anchor='w',pady=2)

		self.top.geometry("+0+0")
		self.top.resizable(0,0)

	# ---------------------------------------------------------------------------
	#
	def load_cb(self):
		path=mstkutil.load_file(self.top,'Open configuration','open_cfg')
		if path!=None:
			settings=peptideslist_settings(self.session,path)
			self.loaded=settings.loaded
			self.show_settings(settings)

	# ---------------------------------------------------------------------------
	#
	def show_settings(self,settings):

		self.value_menu.set_value(settings.data_height)
		self.only_monoisotopic_check.variable.set(settings.only_monoisotopic.get())
		self.log_scale_check.variable.set(settings.log_scale.get())
		self.nan_unchecked_check.variable.set(settings.nan_unchecked)
		self.flag_unchecked_check.variable.set(settings.flag_unchecked)

		self.delta_mz_correction_check.variable.set(settings.delta_mz_correction)
		self.delta_mz_check.variable.set(settings.delta_mz_check)
		self.delta_mz_edit.variable.set(settings.delta_mz_th)

		self.delta_mrt_correction_check.variable.set(settings.delta_mrt_correction)
		self.delta_mrt_check.variable.set(settings.delta_mrt_check)
		self.delta_mrt_edit.variable.set(settings.delta_mrt_th)

		self.mz_rms_check.variable.set(settings.mz_rms_check)
		self.mz_rms_edit.variable.set(settings.mz_rms_th)
		self.mz_rsquare_check.variable.set(settings.mz_rsquare_check)
		self.mz_rsquare_edit.variable.set(settings.mz_rsquare_th)
		self.mz_flag_check.variable.set(settings.mz_flag_check)

		self.rt_rms_check.variable.set(settings.rt_rms_check)
		self.rt_rms_edit.variable.set(settings.rt_rms_th)
		self.rt_rsquare_check.variable.set(settings.rt_rsquare_check)
		self.rt_rsquare_edit.variable.set(settings.rt_rsquare_th)
		self.rt_flag_check.variable.set(settings.rt_flag_check)

		self.mz_env_rms_check.variable.set(settings.mz_env_rms_check)
		self.mz_env_rms_edit.variable.set(settings.mz_env_rms_th)
		self.mz_env_rsquare_check.variable.set(settings.mz_env_rsquare_check)
		self.mz_env_rsquare_edit.variable.set(settings.mz_env_rsquare_th)

		self.fit_rms_check.variable.set(settings.fit_rms_check)
		self.fit_rms_edit.variable.set(settings.fit_rms_th)

		self.peaks_check.variable.set(settings.peaks_check)
		self.peaks_edit.variable.set(settings.peaks_th)


		if settings.view_all.get()=='A':
			entry='All'
		elif settings.view_all.get()=='M':
			entry='Marked'
		elif settings.view_all.get()=='NM':
			entry='Not marked'
		elif settings.view_all.get()=='P':
			entry='Present'
		elif settings.view_all.get()=='NP':
			entry='Not present'
		self.view_menu.set(entry)

		self.view_list_check.variable.set(settings.view_list_only.get())
		if settings.view_list==None or len(settings.view_list)==0:
			self.view_list_check.button.configure(state='disabled')
		else:
			self.view_list_check.button.configure(state='normal')

	# ---------------------------------------------------------------------------
	#
	def get_settings(self):
		settings=peptideslist_settings(self.session)

		settings.data_height=self.value_menu.get_value()
		settings.only_monoisotopic.set(self.only_monoisotopic_check.variable.get())
		settings.log_scale.set(self.log_scale_check.variable.get())
		settings.nan_unchecked=self.nan_unchecked_check.variable.get()
		settings.flag_unchecked=self.flag_unchecked_check.variable.get()

		settings.delta_mz_correction=self.delta_mz_correction_check.variable.get()
		settings.delta_mz_check=self.delta_mz_check.variable.get()
		settings.delta_mz_th=float(self.delta_mz_edit.variable.get())

		settings.delta_mrt_correction=self.delta_mrt_correction_check.variable.get()
		settings.delta_mrt_check=self.delta_mrt_check.variable.get()
		settings.delta_mrt_th=float(self.delta_mrt_edit.variable.get())

		settings.mz_rms_check=self.mz_rms_check.variable.get()
		settings.mz_rms_th=float(self.mz_rms_edit.variable.get())
		settings.mz_rsquare_check=self.mz_rsquare_check.variable.get()
		settings.mz_rsquare_th=float(self.mz_rsquare_edit.variable.get())
		settings.mz_flag_check=self.mz_flag_check.variable.get()

		settings.rt_rms_check=self.rt_rms_check.variable.get()
		settings.rt_rms_th=float(self.rt_rms_edit.variable.get())
		settings.rt_rsquare_check=self.rt_rsquare_check.variable.get()
		settings.rt_rsquare_th=float(self.rt_rsquare_edit.variable.get())
		settings.rt_flag_check=self.rt_flag_check.variable.get()

		settings.mz_env_rms_check=self.mz_env_rms_check.variable.get()
		settings.mz_env_rms_th=float(self.mz_env_rms_edit.variable.get())
		settings.mz_env_rsquare_check=self.mz_env_rsquare_check.variable.get()
		settings.mz_env_rsquare_th=float(self.mz_env_rsquare_edit.variable.get())

		settings.fit_rms_check=self.fit_rms_check.variable.get()
		settings.fit_rms_th=float(self.fit_rms_edit.variable.get())

		settings.peaks_check=self.peaks_check.variable.get()
		settings.peaks_th=float(self.peaks_edit.variable.get())

		entry=self.view_menu.get()
		if entry=='All':
			settings.view_all.set('A')
		elif entry=='Marked':
			settings.view_all.set('M')
		elif entry=='Not marked':
			settings.view_all.set('NM')
		elif entry=='Present':
			settings.view_all.set('P')
		elif entry=='Not present':
			settings.view_all.set('NP')
#		if self.loaded==0:
#			settings.log_scale.set(self.parent_dialog.settings.log_scale.get())

		settings.view_list=self.parent_dialog.settings.view_list
		settings.view_list_only.set(self.view_list_check.variable.get())

		print settings.log_scale.get()

		return settings

	# ---------------------------------------------------------------------------
	#
	def apply_settings_cb(self):
		self.show_window(0)
		self.apply_cb()
		self.close_cb()

	# ---------------------------------------------------------------------------
	#
	def clear_list_cb(self,event=None):
		self.parent_dialog.settings.view_list=None
		self.view_list_check.variable.set(0)
		self.view_list_check.button.configure(state='disabled')

	# ---------------------------------------------------------------------------
	#
	def load_list_cb(self,event=None):
		path=mstkutil.load_file(self.top,'Load list','load_list')
		exact_charge=self.list_charge_check.variable.get()
		sequences=self.load_list(path,exact_charge)

		if sequences!=None and len(sequences)!=0:
			self.parent_dialog.settings.view_list=[]
			peptide_sequences=[]
			for i in range(len(self.parent_dialog.peptide_list)):
				peptide=self.parent_dialog.peptide_list[i]
				for j in range(len(peptide.query_list)):
					peptide_sequences.append(peptide.get_sequence(exact_charge,j))

			for i in range(len(peptide_sequences)):
				found=0
				for j in range(len(sequences)):
					if peptide_sequences[i]==sequences[j]:
						found=1
						break
				self.parent_dialog.settings.view_list.append(found)

			if max(self.parent_dialog.settings.view_list)==0:
				self.parent_dialog.settings.view_list=[]
				self.view_list_check.button.configure(state='disabled')
				dialog=mstkutil.warning_dialog(self.top,'No peptides from list found')
			else:
				self.view_list_check.button.configure(state='normal')

	# --------------------------------------------------------------------------
	#
	def load_list(self,path,exact_charge=0):
		sequences=None

		if path:
			file=open(path,'r')
			sequences=file.readlines()
			file.close()

			if len(sequences)!=0:
				for i in range(len(sequences)-1,-1,-1):
					sequence=sequences[i].strip()
					if sequence=='':
						sequences[i]=[]
					else:
						sequences[i]=sequence

						index=sequence.find(' (+')
						if index!=-1:
							if exact_charge==1:
								index=sequence.find(')',index)+1
							sequences[i]=sequence[:index]
		return sequences