#-*- coding: windows-1250 -*-

import math
import sys
import numpy

import Pmw

import Tkinter
import tkFont
import Image, ImageDraw, ImageTk, ImageFont

import sparky
import msfit
import msnorm
import msmath
import mssputil
import mstkutil
import msproteinslist
import msscatterplot_settings

# -----------------------------------------------------------------------------
#
class scatterplot_dialog(mstkutil.Dialog,mstkutil.Stoppable):

	def __init__(self,session):
		self.session=session
		spectra=session.project.spectrum_list()
		self.settings=msscatterplot_settings.scatterplot_settings(self.session,mstkutil.get_settings('scatterplot.cfg'))
		self.fit=None

		self.X_SCALE=40
		self.Y_SCALE=40
		self.X_SIZE=500
		self.Y_SIZE=500

		mstkutil.Dialog.__init__(self,session.tk,'Scatter plot: ')
		
		#
		#glowny panel
		#
		main_frame=Tkinter.Frame(self.top,relief='flat')
		main_frame.pack(side='top',anchor='w')

		#
		#panel listy
		#
		f=Tkinter.Frame(main_frame,borderwidth=2,relief='groove')
		f.grid(row=0,column=0,rowspan=3,sticky='nwes')

		pl=mssputil.peaks_tablelist(f,height=40,columns=None,selected_edit=0)
		pl.set_columns((30,'Sequence',10,'Protein',11,'Value',11,'Ref. value',7,'Ratio'))
		pl.set_columns_align(('left','left','right','right','right'))
		pl.set_columns_color(('gray98','gray98','#d4deec','#d4deec','gray98'))
		pl.list_size.configure(width=40)

		pl.tablelist.bind('<ButtonRelease-1>',pl.select_peaks_cb)
		pl.tablelist.bind('<Double-ButtonRelease-1>',pl.goto_peaks_cb)
		pl.tablelist.bind('<Return>',pl.goto_peaks_cb)
		pl.tablelist.bind('<Button-3>',self.list_popup_menu)
		
		pl.frame.pack(side='top',fill='both',expand=1)		
		self.tablelist=pl

		#
		#panel z rysunkiem
		#
		f=Tkinter.Frame(main_frame,borderwidth=2,relief='groove')
		f.grid(row=0,column=1,sticky='nwes')

		canvas=Tkinter.Canvas(f,width=self.X_SIZE,height=self.Y_SIZE,background='white')
		canvas.bind('<Button-1>',self.click_cb)
		canvas.bind('<Double-Button-1>',self.double_click_cb)
		canvas.bind('<Button-3>',self.popup_menu)
		canvas.pack()
		self.canvas=canvas


		f=Pmw.Group(main_frame,tag_text='Samples:')
		f.grid(row=1,column=1,sticky='nwes')

		m=mssputil.spectrum_menu(session,f.interior(),'Ref. sample:')
		m.frame.pack(side='right',padx=2,pady=1)
#		m.add_callback(self.update_cb)
		self.spectrum1_menu=m
		self.spectrum1_menu.set(spectra[0].name)

		m=mssputil.spectrum_menu(session,f.interior(),'Sample:')
		m.frame.pack(side='left',padx=2,pady=1)
#		m.add_callback(self.update_cb)
		self.spectrum2_menu=m
		self.spectrum2_menu.set(spectra[1].name)

		
		f=Pmw.Group(main_frame,tag_text='Selected peptide:')
		f.grid(row=2,column=1,sticky='nwes')
		
		if sys.platform=='win32':
			e=mstkutil.entry_field(f.interior(),'','',60)
		else:
			e=mstkutil.entry_field(f.interior(),'','',40)
		e.entry.bind('<Return>',self.mark_sequence_cb)
		e.frame.pack(side='left',padx=2,pady=2)
		e.entry.configure(justify='left')
		self.sequence_edit=e

		image=mstkutil.load_image('list_ledyellow.gif')
		b=Tkinter.Button(f.interior(),borderwidth=1,relief='flat',image=image,command=self.mark_sequence_cb)
		b.image=image
		b.pack(side='left',padx=0,pady=3)
		self.mark_sequence_button=b
		
		image=mstkutil.load_image('list_ledgreen.gif')
		b=Tkinter.Button(f.interior(),borderwidth=1,relief='flat',image=image,command=self.mark_protein_cb)
		b.image=image
		b.pack(side='right',padx=0,pady=3)
		self.mark_protein_button=b

		e=mstkutil.entry_field(f.interior(),'','',10)
		e.entry.bind('<Return>',self.mark_protein_cb)
		e.frame.pack(side='right',padx=2,pady=2)
		e.entry.configure(justify='right')
		self.protein_edit=e


		#main_frame.columnconfigure(0, weight=1)
		#main_frame.columnconfigure(1, weight=1)
#		main_frame.rowconfigure(0, weight=8)
#		main_frame.rowconfigure(1, weight=1)
#		main_frame.rowconfigure(2, weight=1)

#		main_frame.columnconfigure(0, weight=1)
#		main_frame.columnconfigure(1, weight=1)
		
#		sf=Tkinter.Frame(plot_frame,borderwidth=2,relief='groove')
#		sf.pack(side='top',anchor='w',fill='both',expand=1,pady=1)

#		f=Tkinter.Frame(sf,borderwidth=2,relief='flat')
#		f.pack(side='top',anchor='w',fill='both',expand=1)

#		b=Tkinter.Button(f,borderwidth=1,width=13,text='Mark sequence:',command=self.redraw_cb)
#		b.pack(side='left',padx=2,pady=2)

#		if sys.platform=='win32':
#			e=mstkutil.entry_field(f,'','',41)
#		else:
#			e=mstkutil.entry_field(f,'','',21)
#		e.entry.bind('<Return>',self.redraw_cb)
#		e.frame.pack(side='left',padx=2,pady=2)
#		e.entry.configure(justify='right')
#		self.mark_sequence_edit=e

#		if sys.platform=='win32':
#			e=mstkutil.entry_field(f,'','',10)
#		else:
#			e=mstkutil.entry_field(f,'','',7)
#		e.entry.bind('<Return>',self.redraw_cb)
#		e.frame.pack(side='right',padx=2,pady=2)
#		e.entry.configure(justify='right')
#		self.protein_edit=e


#		f=Tkinter.Frame(sf,borderwidth=2,relief='flat')
#		f.pack(side='top',anchor='w',fill='both',expand=1)

#		cb=mstkutil.checkbutton(f,'Only exact match',1)
#		cb.button.pack(side='left',padx=2,pady=2)
#		self.match_check=cb
		
#		cb=mstkutil.checkbutton(f,'Mark from list',0)
#		cb.add_callback(self.update_plot_cb)
#		cb.button.configure(state='disabled')
#		cb.button.pack(side='right',padx=2,pady=2)
#		self.mark_list_check=cb

		#
		#pasek postepu i przyciski
		#
		progress_label=Tkinter.Label(self.top, anchor='nw')
		progress_label.pack(side='top',anchor='w')

		br=mstkutil.button_row(self.top,
				('Update', self.update_cb),
				('Stop', self.stop_cb),
				('Setup', self.setup_cb),
				('Save plot', self.save_cb),
				('Save list', self.tablelist.save_cb),
				('Close', self.top.destroy))
		br.frame.pack(side='bottom',anchor='w',pady=2)
		self.buttons_row=br

		self.top.geometry("+0+0")
		self.top.resizable(1,0)

		self.removed_notice=session.notify_me('removed spectrum from project',self.update_menu_cb)
		self.added_notice=session.notify_me('added spectrum to project',self.update_menu_cb)
		self.selection_notice=session.notify_me('selection changed',self.selection_changed_cb)
		self.dragging_notice=session.notify_me('dragged peak',self.peak_dragged_cb)
		self.top.bind('<Destroy>',self.remove_callbacks,1)
		self.top.protocol("WM_DELETE_WINDOW",self.closing_window)

		mstkutil.Stoppable.__init__(self,progress_label,br.buttons[1])

	# -----------------------------------------------------------------------------
	#
	def popup_menu(self,event):
		if self.settings.lock_callbacks==0:
			menu=Tkinter.Menu(self.canvas,tearoff=0)

			plot_submenu=Tkinter.Menu(menu,tearoff=0)
			plot_submenu.add_radiobutton(label='Scatter plot',variable=self.settings.plot_mva,value=0,command=self.plottype_cb)
			plot_submenu.add_radiobutton(label='MvA plot',variable=self.settings.plot_mva,value=1,command=self.plottype_cb)
			menu.add_cascade(label='Plot type',menu=plot_submenu)
			
			view_submenu=Tkinter.Menu(menu,tearoff=0)
			view_submenu.add_checkbutton(label='Fit',variable=self.settings.plot_fit,command=self.update_plot_cb)
			view_submenu.add_checkbutton(label='Thresholds',variable=self.settings.plot_thr,command=self.update_plot_cb)
			menu.add_cascade(label='View',menu=view_submenu)

			menu.tk_popup(event.x_root,event.y_root)

	# -----------------------------------------------------------------------------
	#
	def list_popup_menu(self,event):
		if self.settings.lock_callbacks==0:
			menu=Tkinter.Menu(self.tablelist.tablelist,tearoff=0)

			menu.add_command(label='Mark protein',command=self.mark_protein_cb)
			menu.add_command(label='Mark sequence',command=self.mark_sequence_cb)
			menu.add_separator()

			view_submenu=Tkinter.Menu(menu,tearoff=0)
			view_submenu.add_radiobutton(label='Present in any sample',variable=self.settings.view_mode,value=msscatterplot_settings.VIEW_PRESENT,command=self.update_cb)
			view_submenu.add_radiobutton(label='Present in single sample',variable=self.settings.view_mode,value=msscatterplot_settings.VIEW_PRESENT_SINGLE,command=self.update_cb)
			view_submenu.add_radiobutton(label='Present in both samples',variable=self.settings.view_mode,value=msscatterplot_settings.VIEW_PRESENT_BOTH,command=self.update_cb)
			view_submenu.add_radiobutton(label='Not present in both samples',variable=self.settings.view_mode,value=msscatterplot_settings.VIEW_PRESENT_NONE,command=self.update_cb)
			view_submenu.add_radiobutton(label='All',variable=self.settings.view_mode,value=msscatterplot_settings.VIEW_ALL,command=self.update_cb)
			view_submenu.add_separator()
			view_submenu.add_checkbutton(label='Ratios over threshold',variable=self.settings.view_over_th,command=self.update_list_cb)
			view_submenu.add_separator()
			if self.settings.view_list==None or len(self.settings.view_list)==0:
				view_submenu.add_checkbutton(label='Only from list',variable=self.settings.view_list_only,command=self.view_list_cb,state='disabled')
			else:
				view_submenu.add_checkbutton(label='Only from list',variable=self.settings.view_list_only,command=self.view_list_cb,state='normal')
			menu.add_cascade(label='View',menu=view_submenu)

			#menu.add_separator()
			#menu.add_command(label='Proteins list',command=self.proteins_cb)

			menu.tk_popup(event.x_root,event.y_root)
			
	# ---------------------------------------------------------------------------
	#
	def closing_window(self):
		if self.settings.lock_callbacks==0:
			self.top.destroy()
					
	# ---------------------------------------------------------------------------
	#
	def remove_callbacks(self,event):
		if str(self.top)==str(event.widget):
			if sparky.object_exists(self.session):
				if self.removed_notice!=None:
					self.session.dont_notify_me(self.removed_notice)
				if self.added_notice!=None:
					self.session.dont_notify_me(self.added_notice)
				if self.selection_notice!=None:
					self.session.dont_notify_me(self.selection_notice)
				if self.dragging_notice!=None:
					self.session.dont_notify_me(self.dragging_notice)
					
			self.removed_notice=None
			self.added_notice=None
			self.selection_notice=None
			self.dragging_notice=None

	# ---------------------------------------------------------------------------
	#
	def update_menu_cb(self,removed_spectrum):
		spectra=self.session.project.spectrum_list()
		if spectra==None or len(spectra)<2:
			self.top.destroy()
		else:
			if self.spectrum1!=removed_spectrum:
				spectrum1=self.spectrum1
			else:
				spectrum1=spectra[0]

			if self.spectrum2!=removed_spectrum:
				spectrum2=self.spectrum2
			else:
				spectrum2=spectra[1]

			self.spectrum1_menu.update_menu_cb()
			self.spectrum1_menu.set(spectrum1.name)
			self.spectrum2_menu.update_menu_cb()
			self.spectrum2_menu.set(spectrum2.name)

			if spectrum1!=self.spectrum1 or spectrum2!=self.spectrum2:
				self.update_cb()

	# ---------------------------------------------------------------------------
	#
	def selection_changed_cb(self):
		peaks=self.session.selected_peaks()
		if peaks!=None and len(peaks)==1:
			for i in range(len(self.peaks1)):
				if self.peaks1[i]==peaks[0] or self.peaks2[i]==peaks[0]:
					selected=self.find_point(i)
					if selected!=None:
						if self.settings.last_selected!=None:
							self.canvas.itemconfig(self.settings.last_selected,fill=self.settings.last_color,outline=self.settings.last_outline)

						self.settings.last_selected=selected
						self.settings.last_color=self.canvas.itemcget(selected,'fill')
						self.settings.last_outline=self.canvas.itemcget(selected,'outline')

						self.canvas.itemconfig(selected,fill=self.settings.dot_selected_fill,outline='black')
						self.canvas.lift(selected)
						
						self.tablelist.mark_peak_cb(peaks[0])
						self.update_info(i)
					else:
						if self.settings.last_selected!=None:
							self.canvas.itemconfig(self.settings.last_selected,fill=self.settings.last_color,outline=self.settings.last_outline)
							self.settings.last_selected=None
					break

	# ---------------------------------------------------------------------------
	#
	def peak_dragged_cb(self,peak):
		if peak.spectrum==self.spectrum1 or peak.spectrum==self.spectrum2:
			print peak
#			line_index=self.peptide_tablelist.find_peak_cb(peak)
#			if line_index!=-1 and (self.settings.view_list_only.get()==0 or (self.settings.view_list_only.get()==1 and self.settings.view_list[int(line_index)]==1)):
#				self.update_query(line_index)
#				if peak.selected==1:
#					self.peptide_tablelist.selected_peak=None
#					self.peptide_tablelist.mark_peak_cb(peak)
					
	# ---------------------------------------------------------------------------
	#
	def click_cb(self,event):
		selected=self.canvas.find_withtag('current')
		if selected and self.canvas.type(selected)=='oval':

			if self.settings.last_selected:
				self.canvas.itemconfig(self.settings.last_selected,fill=self.settings.last_color,outline=self.settings.last_outline)

			self.settings.last_selected=selected
			self.settings.last_color=self.canvas.itemcget(selected,'fill')
			self.settings.last_outline=self.canvas.itemcget(selected,'outline')

			self.canvas.itemconfig('current',fill=self.settings.dot_selected_fill,outline='black')
#			self.canvas.update_idletasks()
#			self.canvas.after(200)

			index=int(self.canvas.gettags(selected)[0])
			mssputil.select_peak(self.peaks2[index])
			mssputil.select_peak(self.peaks1[index])
			self.update_info(index)
			self.sequence_edit.entry.focus_set()

	# ---------------------------------------------------------------------------
	#
	def double_click_cb(self,event):
		selected=self.canvas.find_withtag('current')
		if selected and self.canvas.type(selected)=='oval':
			index=int(self.canvas.gettags(selected)[0])
			mssputil.show_peak(self.peaks2[index])
			mssputil.show_peak(self.peaks1[index])

	# ---------------------------------------------------------------------------
	#
	def mark_sequence_cb(self,event=None):

		if self.settings.mark_sequence==None:
			sequence=self.sequence_edit.variable.get().strip().lower()
			index=sequence.find(' (+')
			if index!=-1:
				sequence=sequence[0:index]
			if sequence!='':
				image=mstkutil.load_image('list_ledyellow_h.gif')
				self.settings.mark_sequence=sequence
				state='disabled'
		else:
			image=mstkutil.load_image('list_ledyellow.gif')
			self.settings.mark_sequence=None
			state='normal'

		self.sequence_edit.entry['state']=state
		self.mark_sequence_button['image']=image
		self.mark_sequence_button.image=image
		self.update_plot_cb()

	# ---------------------------------------------------------------------------
	#
	def mark_protein_cb(self,event=None):
		if self.settings.mark_protein==None:
			protein=self.protein_edit.variable.get().strip().lower()
			if protein!='':
				image=mstkutil.load_image('list_ledgreen_h.gif')
				self.settings.mark_protein=protein
				state='disabled'
		else:
			image=mstkutil.load_image('list_ledgreen.gif')
			self.settings.mark_protein=None
			state='normal'

		self.protein_edit.entry['state']=state
		self.mark_protein_button['image']=image
		self.mark_protein_button.image=image
		self.update_plot_cb()

	# ---------------------------------------------------------------------------
	#
	def save_cb(self):
		path=mstkutil.save_file(self.canvas,'Save Postscript','save_postscript')
		if path!=None and len(path)>0:
			self.canvas.postscript(file=path,pageheight=self.X_SIZE,pagewidth=self.Y_SIZE)

	# ---------------------------------------------------------------------------
	#
	def plottype_cb(self):
		self.fit=None
		self.fit_x=None

		self.update_plot_cb()
		
	# ---------------------------------------------------------------------------
	#
	def update_plot_cb(self,event=None):
		spectrum1=self.spectrum1_menu.spectrum()
		spectrum2=self.spectrum2_menu.spectrum()

		self.lock_gui(1)
		self.create_scatterplot(spectrum1,spectrum2)
		self.lock_gui(0)

	# ---------------------------------------------------------------------------
	#
	def update_cb(self,event=None):
		self.lock_gui(1)
		self.fit=None
		self.fit_x=None
		
		if self.create_scatterplot(self.spectrum1_menu.spectrum(),self.spectrum2_menu.spectrum())==1:
			self.stoppable_call(self.create_list)
		
#		if self.settings.proteins_list!=None:
#			self.settings.proteins_list.update_cb()
		self.lock_gui(0)

	# ---------------------------------------------------------------------------
	#
	def update_plot_cb(self,event=None):
		spectrum1=self.spectrum1_menu.spectrum()
		spectrum2=self.spectrum2_menu.spectrum()
		
		self.lock_gui(1)
		self.create_scatterplot(spectrum1,spectrum2)
		self.lock_gui(0)

	# ---------------------------------------------------------------------------
	#
	def update_list_cb(self,event=None):
		self.lock_gui(1)
		self.stoppable_call(self.create_list)
		self.lock_gui(0)	

	# ---------------------------------------------------------------------------
	#
	def update_info(self,index):
		if self.sequence_edit.entry['state']=='normal':
			self.sequence_edit.variable.set(mssputil.get_sequence(self.peaks1[index]) + ' (+' + ('%d' % mssputil.get_charge(self.peaks1[index])) +')')
		if self.protein_edit.entry['state']=='normal':
			self.protein_edit.variable.set(mssputil.get_protein(self.peaks1[index]))

	# ---------------------------------------------------------------------------
	#
	def find_point(self,index):
		point=None
		
		items=self.canvas.find_all()
		for i in range(len(items)):
			if self.canvas.type(items[i])=='oval':
				if int(self.canvas.gettags(items[i])[0])==index:
					point=items[i]
					break
		return point

	# ---------------------------------------------------------------------------
	#
	def proteins_cb(self):
		self.settings.proteins_list=mssputil.the_dialog(msproteinslist.proteins_list_dialog,self.session)
		self.settings.proteins_list.show_window(1)
		self.settings.proteins_list.set_parent_dialog(self,self.settings,None)
		
	# ---------------------------------------------------------------------------
	#
	def lock_gui(self,lock):

		if lock==1:
			state='disabled'
			if sys.platform=='win32':
				cursor='wait'
			else:
				cursor='watch'
		else:
			state='normal'
			cursor=''

		self.settings.lock_callbacks=lock
		self.tablelist.lock_callbacks=lock

		self.buttons_row.buttons[0]['state']=state
		self.buttons_row.buttons[2]['state']=state
		self.buttons_row.buttons[3]['state']=state
		self.buttons_row.buttons[4]['state']=state
		self.buttons_row.buttons[5]['state']=state
		self.top.config(cursor=cursor)
		self.top.update_idletasks()

	# ---------------------------------------------------------------------------
	#
	def get_values(self):
		peaks_count=len(self.peaks1)

		self.x_vals=numpy.zeros(peaks_count)
		self.y_vals=numpy.zeros(peaks_count)
		
		self.progress_report('Getting values')
		self.stoppable_loop('peaks',200)
		for i in range(peaks_count):
			self.check_for_stop()
			peak1=self.peaks1[i]
			peak2=self.peaks2[i]

			#poprawki zalezne od view_mode
			if mssputil.is_peak_present(peak1)==1:
				if self.settings.data_height>=0:
					self.x_vals[i]=msfit.get_fit_value(peak1,self.settings.data_height)
				else:
					self.x_vals[i]=mssputil.get_rt(peak1)
			else:
				self.x_vals[i]=numpy.nan
				
			if mssputil.is_peak_present(peak2)==1:
				if self.settings.data_height>=0:
					self.y_vals[i]=msfit.get_fit_value(peak2,self.settings.data_height)
				else:
					self.y_vals[i]=mssputil.get_rt(peak2)
			else:
				self.y_vals[i]=numpy.nan
		
		self.progress_report('Normalizing values')
		if self.settings.norm_method!=msnorm.NORM_NONE:
			if self.settings.norm_method==msnorm.NORM_GLOBAL_MEDIAN or self.settings.norm_method==msnorm.NORM_GLOBAL_MEAN or self.settings.norm_method==msnorm.NORM_GLOBAL_GMEAN:
				msnorm.global_normalization(self.x_vals,self.y_vals,self.settings.norm_method)
			elif self.settings.norm_method==msnorm.NORM_USER:
				msnorm.global_normalization(self.x_vals,self.y_vals,self.settings.norm_method,self.settings.norm_factor)
			elif self.settings.norm_method==msnorm.NORM_TOTAL_COUNTS:
				if self.spectrum1.total_counts!=0 and self.spectrum2.total_counts!=0:
					norm_factor=self.spectrum1.total_counts/self.spectrum2.total_counts
					msnorm.global_normalization(self.x_vals,self.y_vals,self.settings.norm_method,norm_factor)
			elif self.settings.norm_method==msnorm.NORM_PROTEIN_MEDIAN or self.settings.norm_method==msnorm.NORM_PROTEIN_MEAN or self.settings.norm_method==msnorm.NORM_PROTEIN_GMEAN:
				norm_factor=msnorm.get_protein_norm_factor(self.x_vals,self.y_vals,self.settings.norm_method,self.peaks1,self.settings.norm_protein)
				msnorm.global_normalization(self.x_vals,self.y_vals,self.settings.norm_method,norm_factor)
			elif self.settings.norm_method==msnorm.NORM_LOWESS:
				msnorm.lowess_normalization(self.x_vals,self.y_vals,self.session,(self.settings.data_height>=0),self.settings.fit_f,self.settings.fit_nsteps,0)
		
		if self.settings.data_height>=0:
			self.x_vals=numpy.log10(self.x_vals)
			self.y_vals=numpy.log10(self.y_vals)

	# ---------------------------------------------------------------------------
	#
	def get_thresholds(self):
		if self.settings.data_height>=0:
			low_th=math.log(1/self.settings.ratio_th,10)
			high_th=math.log(self.settings.ratio_th,10)
		else:
			low_th=-1*self.settings.ratio_th
			high_th=self.settings.ratio_th

		return(low_th,high_th)
	
	# ---------------------------------------------------------------------------
	#
	def get_ranges(self,points_x,points_y):

		min_x=numpy.nanmin(points_x)
		if numpy.isfinite(min_x)==0:
			min_x=0;
		max_x=numpy.nanmax(points_x)
		if numpy.isfinite(max_x)==0 or max_x==0:
			max_x=1;

		min_y=numpy.nanmin(points_y)
		if numpy.isfinite(min_y)==0:
			min_y=0;
		max_y=numpy.nanmax(points_y)
		if numpy.isfinite(max_y)==0 or max_y==0:
			max_y=1;
				
		if self.settings.plot_mva.get()==1:
			self.ranges=[min_x-1,max_x+1,min_y-1,max_y+1]
		else:
			max_x=math.ceil(10*(max_x+1))/10
			max_y=math.ceil(10*(max_y+1))/10

			self.ranges=[0,max_x,0,max_y]
			
		self.steps=[(self.X_SIZE-self.X_SCALE)/(self.ranges[1]-self.ranges[0]),(self.Y_SIZE-self.Y_SCALE)/(self.ranges[3]-self.ranges[2])]

	# ---------------------------------------------------------------------------
	#
	def get_x(self,x):
		return((x-self.ranges[0])*self.steps[0]+self.X_SCALE);

	# ---------------------------------------------------------------------------
	#
	def get_y(self,y):
		return(self.Y_SIZE-self.Y_SCALE-(y-self.ranges[2])*self.steps[1]);
	
	# ---------------------------------------------------------------------------
	#
	def plot_scale(self):
		self.canvas.delete('all')

		font_size=12
		if sys.platform=='win32':
			font_size=10
		name_font=tkFont.Font(family="Courier",size=font_size,weight="bold")

		#Y
		self.canvas.create_line(self.X_SCALE,0,self.X_SCALE,self.Y_SIZE, width=1,fill='black')
		if self.settings.data_height>=0 or self.settings.plot_mva.get()==1:
			ticks=range(int(self.ranges[2])+1,int(self.ranges[3])+1)
		else:
			ticks=range(int(self.ranges[2])+10,int(self.ranges[3])+10,10)
			
		for tick in ticks:
			y=self.get_y(tick)
			self.canvas.create_line(self.X_SCALE,y,self.X_SCALE-5,y,width=1,fill='black')
			self.canvas.create_text(self.X_SCALE-10,y,text=tick)
#			print tick

		#X
		self.canvas.create_line(0,self.Y_SIZE-self.Y_SCALE, self.X_SIZE,self.Y_SIZE-self.Y_SCALE,width=1,fill='black')
		if self.settings.data_height>=0:
			ticks=range(int(self.ranges[0])+1,int(self.ranges[1])+1)
		else:
			ticks=range(int(self.ranges[0])+10,int(self.ranges[1])+10,10)

		for tick in ticks:
			x=self.get_x(tick)
			self.canvas.create_line(x,self.Y_SIZE-self.Y_SCALE,x,self.Y_SIZE-self.Y_SCALE+5,width=1,fill='black')
			self.canvas.create_text(x,self.Y_SIZE-self.Y_SCALE+10,text=tick)
		
		if self.settings.plot_mva.get()==1:
			self.canvas.create_line(self.get_x(self.ranges[0]),self.get_y(0),self.get_x(self.ranges[1]),self.get_y(0),width=1,fill='gray25')

			self.canvas.create_text(self.X_SIZE/2+self.X_SCALE,self.Y_SIZE-self.Y_SCALE+30,text='A',font=name_font)
			self.canvas.create_text(12,self.Y_SIZE/2-self.Y_SCALE,text='M',font=name_font)
		else:
			if self.ranges[1]>self.ranges[3]:
				self.canvas.create_line(self.get_x(0),self.get_y(0),self.get_x(self.ranges[1]),self.get_y(self.ranges[1]),width=1,fill='gray25')
			else:
				self.canvas.create_line(self.get_x(0),self.get_y(0),self.get_x(self.ranges[3]),self.get_y(self.ranges[3]),width=1,fill='gray25')

			font=mstkutil.load_pil_font('arial',13)
			
			text_image=Image.new('RGB',(int(11*len(self.spectrum2.name)),20),'white')
			draw=ImageDraw.Draw(text_image)
			draw.text((0,0),self.spectrum2.name,font=font,fill='black')
			text_size=draw.textsize(self.spectrum2.name,font=font)

			self.canvas.text_image1=ImageTk.PhotoImage(text_image.rotate(-90))
			self.canvas.create_image(0,(self.Y_SIZE-self.Y_SCALE)/2-text_size[0]/2,anchor='nw',image=self.canvas.text_image1)

			text_image=Image.new('RGB',(int(11*len(self.spectrum2.name)),20),'white')
			draw=ImageDraw.Draw(text_image)
			draw.text((0,0),self.spectrum1.name,font=font,fill='black')
			text_size=draw.textsize(self.spectrum1.name,font=font)

			self.canvas.text_image2=ImageTk.PhotoImage(text_image)
			self.canvas.create_image(self.X_SIZE/2+self.X_SCALE-text_size[0]/2,self.Y_SIZE-15,anchor='nw',image=self.canvas.text_image2)
			
	# ---------------------------------------------------------------------------
	#
	def plot_points(self,points_x,points_y):
		mark_list=0
		#if self.mark_list_check.variable.get()==1 and self.settings.view_list!=None and len(self.settings.view_list)!=0:
		#	mark_list=1
		#else:
		#	mark_list=0
		from_list=[]

		from_protein=[]
		from_sequence=[]
		selected_point=None

		peaks_count=len(points_x)
		counter=-1
		for i in range(peaks_count):
			counter=counter+1
			if self.settings.view_list_only.get()==1 and self.settings.view_list[counter]==0:
				continue

			if numpy.isfinite(points_x[i]):
				x=points_x[i]
			else:
				x=0
			if numpy.isfinite(points_y[i]):
				y=points_y[i]
			else:
				y=0

			if x!=0 and y!=0:
				if self.settings.view_mode.get()==msscatterplot_settings.VIEW_PRESENT_SINGLE or self.settings.view_mode.get()==msscatterplot_settings.VIEW_PRESENT_NONE:
					continue
			else:
				if self.settings.plot_mva.get()==1:
					continue
					
				if self.settings.view_mode.get()!=msscatterplot_settings.VIEW_ALL and self.settings.view_mode.get()!=msscatterplot_settings.VIEW_PRESENT_NONE:
					if x==0 and y==0:
						continue

				if self.settings.view_mode.get()==msscatterplot_settings.VIEW_PRESENT_NONE:
					if x!=0 or y!=0:
						continue
						
				if self.settings.view_mode.get()==msscatterplot_settings.VIEW_PRESENT_BOTH:
					continue

			x=self.get_x(x)
			y=self.get_y(y)
			item=self.canvas.create_oval(x-self.settings.dot_size,y-self.settings.dot_size,x+self.settings.dot_size,y+self.settings.dot_size,fill=self.settings.dot_fill,outline=self.settings.dot_outline,tag=(i,'point'))

			if self.peaks1[i].selected==1 or self.peaks2[i].selected==1:
				selected_point=item
			if self.settings.mark_protein!=None and mssputil.get_protein(self.peaks1[i]).strip().lower()==self.settings.mark_protein:
				from_protein.append(item)
			if self.settings.mark_sequence!=None and mssputil.get_sequence(self.peaks1[i]).strip().lower()==self.settings.mark_sequence:
				from_sequence.append(item)
			if mark_list==1 and self.settings.view_list[counter]!=0:
				from_list.append(item)

		for p in from_protein:
			self.canvas.lift(p)
			self.canvas.itemconfig(p,fill=self.settings.dot_protein_fill,outline='black')
			if p==selected_point:
				self.settings.last_color=self.settings.dot_protein_fill
				self.settings.last_outline='black'

		for p in from_sequence:
			self.canvas.lift(p)
			self.canvas.itemconfig(p,fill=self.settings.dot_sequence_fill,outline='black')
			if p==selected_point:
				self.settings.last_color=self.settings.dot_sequence_fill
				self.settings.last_outline='black'

		for p in from_list:
			self.canvas.lift(p)
			self.canvas.itemconfig(p,fill=self.settings.dot_list_fill,outline='black')
			if p==selected_point:
				self.settings.last_color=self.settings.dot_list_fill
				self.settings.last_outline='black'

		if selected_point!=None:
			self.canvas.lift(selected_point)
			self.canvas.itemconfig(selected_point,fill=self.settings.dot_selected_fill,outline='black')
			self.settings.last_selected=selected_point
			self.update_info(int(self.canvas.gettags(selected_point)[0]))
		
		self.canvas.update_idletasks()

	# ---------------------------------------------------------------------------
	#
	def plot_fit(self,points_x,points_y):
		if self.fit==None:
			idx=numpy.isfinite(points_x)*numpy.isfinite(points_y)
			if numpy.sum(idx)>0:
				points_x=points_x[idx]
				points_y=points_y[idx]

				sort_idx=numpy.argsort(points_x)
				points_x=points_x[sort_idx]
				points_y=points_y[sort_idx]
			
				self.fit,inliers_index=msmath.lowess(self.session,points_x,points_y,self.settings.fit_f,self.settings.fit_nsteps,0,0)
				self.fit_x=points_x

		if self.fit!=None:
			for i in range(1,len(self.fit)):
				x0=self.get_x(self.fit_x[i-1])
				x1=self.get_x(self.fit_x[i])

				y0=self.get_y(self.fit[i-1])
				y1=self.get_y(self.fit[i])
				item=self.canvas.create_line(x0,y0,x1,y1,fill='black',width=3,smooth=1)

			self.canvas.update_idletasks()

	# ---------------------------------------------------------------------------
	#
	def plot_thresholds(self):
		(low_th,high_th)=self.get_thresholds()
		if self.settings.plot_mva.get()==1:
			line=self.canvas.create_line(self.get_x(self.ranges[0]),self.get_y(low_th),self.get_x(self.ranges[1]),self.get_y(low_th),width=1,fill='gray')
			self.canvas.lower(line)
			line=self.canvas.create_line(self.get_x(self.ranges[0]),self.get_y(high_th),self.get_x(self.ranges[1]),self.get_y(high_th),width=1,fill='gray')
			self.canvas.lower(line)
		else:
			line=self.canvas.create_line(self.get_x(self.ranges[0]),self.get_y(low_th),self.get_x(self.ranges[1]),self.get_y(self.ranges[1]+low_th),width=1,fill='gray')
			self.canvas.lower(line)
			line=self.canvas.create_line(self.get_x(self.ranges[0]),self.get_y(high_th),self.get_x(self.ranges[1]),self.get_y(self.ranges[1]+high_th),width=1,fill='gray')
			self.canvas.lower(line)

	# ---------------------------------------------------------------------------
	#
	def create_scatterplot(self,spectrum1,spectrum2):
		result=0
		
		peaks1=mssputil.get_assinged_peaks(spectrum1)
		peaks2=mssputil.get_assinged_peaks(spectrum2)

		if peaks1!=None and peaks2!=None and len(peaks1)!=0 and len(peaks2)!=0 and len(peaks1)==len(peaks2):
			self.spectrum1=spectrum1
			self.spectrum2=spectrum2

			self.peaks1=peaks1
			self.peaks2=peaks2

			self.settings.last_selected=None
			self.settings.last_color=self.settings.dot_fill
			self.settings.last_outline=self.settings.dot_outline

			self.fit=None
			self.fit_x=None

			self.stoppable_call(self.get_values)

			if self.settings.plot_mva.get()==1:
				points_x=0.5*(self.x_vals+self.y_vals)
				points_y=self.y_vals-self.x_vals
			else:
				points_x=self.x_vals
				points_y=self.y_vals

			self.get_ranges(points_x,points_y)
			self.plot_scale()
			self.plot_points(points_x,points_y)
			
			if self.settings.plot_fit.get()==1:
				self.plot_fit(points_x,points_y)
			if self.settings.plot_thr.get()==1:
				self.plot_thresholds()

			self.top.title('Scatter plot: ' + self.spectrum2.name + ' vs '+ self.spectrum1.name)
			self.spectrum1_menu.set(self.spectrum1.name)
			self.spectrum2_menu.set(self.spectrum2.name)

			result=1
		else:
			self.show_window(1)	
			dialog=mstkutil.warning_dialog(self.top,'Inequal number of peaks in spectra!!!')
		
		return(result)


	# ---------------------------------------------------------------------------
	#
	def create_list(self,event=None):
		self.progress_report('Creating list')
		self.tablelist.lock_callbacks=1

		format='%0.3f'
		(low_th,high_th)=self.get_thresholds()
		if self.settings.data_height>=0:
			self.tablelist.tablelist.columnconfigure(4,title='log(Ratio)')				
		else:
			self.tablelist.tablelist.columnconfigure(4,title='Diff')

		selected_peak=None
		row_index=int(round(self.tablelist.tablelist.yview()[0]*self.tablelist.tablelist.size()))
		self.tablelist.clear()

		peaks_count=len(self.peaks1)
		counter=-1
		query_counter=0
		
		self.stoppable_loop('peaks',200)
		for i in range(peaks_count):
			self.check_for_stop()
			hide=0
			over_th=0
			if self.x_vals[i]!=-1:
				counter=counter+1
				if self.peaks1[i].selected==1 or self.peaks2[i].selected==1:
					selected_peak=self.peaks1[i]
		
				if self.settings.view_list_only.get()==1 and self.settings.view_list[counter]==0:
					self.tablelist.append(('','','','',''),(self.peaks1[i],self.peaks2[i]))
					self.tablelist.tablelist.rowconfigure(counter,hide=1)
				else:
					sequence_str=mssputil.get_sequence(self.peaks1[i]) + ( ' (+%d)' % mssputil.get_charge(self.peaks1[i]))

					x_val=self.x_vals[i]
					if numpy.isfinite(x_val):
						x_val_str=format % x_val
					else:
						x_val_str='NaN'
	
					y_val=self.y_vals[i]
					if numpy.isfinite(y_val):
						y_val_str=format % y_val
					else:
						y_val_str='NaN'
						
					if numpy.isfinite(x_val)!=0 and numpy.isfinite(y_val)!=0:
						ratio=y_val-x_val
						ratio_str=format % ratio
					else:
						ratio=numpy.nan
						if numpy.isfinite(x_val)==1:
							ratio_str='D'
						elif numpy.isfinite(y_val)==1:
							ratio_str='U'
						else:
							ratio_str='NaN'
							
					self.tablelist.append((sequence_str,mssputil.get_protein(self.peaks1[i]),y_val_str,x_val_str,ratio_str),(self.peaks1[i],self.peaks2[i]))

					if numpy.isfinite(ratio)==1:
						if self.settings.view_mode.get()==msscatterplot_settings.VIEW_PRESENT_SINGLE or self.settings.view_mode.get()==msscatterplot_settings.VIEW_PRESENT_NONE:
							hide=1

						if ratio>=high_th:
							self.tablelist.configure_cell(counter,4,foreground=self.settings.ratio_up_color)
							over_th=1
						elif ratio<=low_th:
							self.tablelist.configure_cell(counter,4,foreground=self.settings.ratio_down_color)
							over_th=1
					else:
						if self.settings.view_mode.get()!=msscatterplot_settings.VIEW_ALL:
							if numpy.isfinite(x_val)==0 and numpy.isfinite(y_val)==0 and self.settings.view_mode.get()!=msscatterplot_settings.VIEW_PRESENT_NONE:
								hide=1

						if self.settings.view_mode.get()==msscatterplot_settings.VIEW_PRESENT_NONE:
							if numpy.isfinite(x_val)!=0 or numpy.isfinite(y_val)!=0:
								hide=1
								
						if self.settings.view_mode.get()==msscatterplot_settings.VIEW_PRESENT_BOTH:
							hide=1

						if numpy.isfinite(x_val)!=1:
							self.tablelist.configure_cell(counter,3,foreground='red')
							over_th=1
							
						if numpy.isfinite(y_val)!=1:
							self.tablelist.configure_cell(counter,2,foreground='red')
							over_th=1
								
						self.tablelist.configure_cell(counter,4,foreground=self.settings.ratio_nan_color)

					if self.settings.view_over_th.get()==1 and over_th==0:
						hide=1

					if hide==1:
						self.tablelist.tablelist.rowconfigure(counter,hide=1)
					else:
						query_counter=query_counter+1

		self.tablelist.list_size.configure(text=('%d PSMs' % query_counter))

		self.tablelist.lock_callbacks=0
		if selected_peak==None:
			self.tablelist.tablelist.yview(row_index)
			self.tablelist.set_sequence('')
		else:
			self.tablelist.mark_peak_cb(selected_peak)

	# ---------------------------------------------------------------------------
	#
	def view_list_cb(self,event=None):
		if self.settings.view_list_only.get()==1:
			if self.settings.view_list==None or len(self.settings.view_list)==0:
				dialog=mstkutil.warning_dialog(self.top,'The list is empty')
				self.settings.view_list_only.set(0)
				return
		self.update_cb()

	# ---------------------------------------------------------------------------
	#
	def setup_cb(self):
		psd=mssputil.the_dialog(msscatterplot_settings.scatterplot_settings_dialog,self.session)
		psd.set_parent_dialog(self,self.settings,self.new_settings)
#		psd.top.title(self.title + ' settings')
		psd.show_window(1)

	# ---------------------------------------------------------------------------
	#
	def new_settings(self,settings):
		self.settings=settings
#		if self.settings.view_list!=None and len(self.settings.view_list)!=0:
#			self.mark_list_check.button.configure(state='normal')
#		else:
#			self.mark_list_check.button.configure(state='disabled')
		self.update_cb()


# -----------------------------------------------------------------------------
#
def show_scatterplot(session):

	spectra=session.project.spectrum_list()
	if spectra!=None and len(spectra)>=2: 
#		d=mssputil.the_dialog(scatterplot_dialog,session);
		d=scatterplot_dialog(session);
		d.show_window(1)
		d.update_cb()

